#include "sbblowfish.h"

SB_PHP_METHOD(TSBBlowfishContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBBlowfishContext));
		intern->len = sizeof(TSBBlowfishContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBBlowfishContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBBlowfishContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBBlowfishContext, get_P0)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P0)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P3)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P3)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P4)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P4)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P5)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P5)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P6)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P6)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P7)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P7)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P8)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P8)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P9)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P9)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P10)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P10)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P11)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P11)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P12)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P12)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P13)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P13)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P14)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P14)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P15)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P15)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P16)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P16)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBBlowfishContext, get_P17)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TSBBlowfishContext, set_P17)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

zend_class_entry *TSBBlowfishContext_ce_ptr = NULL;

static zend_function_entry TSBBlowfishContext_methods[] = {
	PHP_ME(TSBBlowfishContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBBlowfishContext, get_P0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P3, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P3, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P4, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P4, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P5, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P5, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P6, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P6, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P7, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P7, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P8, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P8, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P9, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P9, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P10, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P10, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P11, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P11, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P12, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P12, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P13, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P13, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P14, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P14, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P15, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P15, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P16, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P16, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, get_P17, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBlowfishContext, set_P17, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBBlowfishContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBBlowfishContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBBlowfishContext", TSBBlowfishContext_methods);
	TSBBlowfishContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBBlowfish, EncryptBlock)
{
	uint32_t u4LRaw;
	uint32_t u4RRaw;
	zval *oContext;
	zval *zu4L;
	zval *zu4R;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oContext, TSBBlowfishContext_ce_ptr, &zu4L, &zu4R) == SUCCESS) && PZVAL_IS_REF(oContext) && PZVAL_IS_REF(zu4L) && (IS_LONG == Z_TYPE_P(zu4L)) && PZVAL_IS_REF(zu4R) && (IS_LONG == Z_TYPE_P(zu4R)))
	{
		u4LRaw = (uint32_t)Z_LVAL_P(zu4L);
		u4RRaw = (uint32_t)Z_LVAL_P(zu4R);
		SBCheckError(SBBlowfish_EncryptBlock((TSBBlowfishContext *)SBGetStructPointer(oContext TSRMLS_CC), &u4LRaw, &u4RRaw) TSRMLS_CC);
		ZVAL_LONG(zu4L, (long)u4LRaw);
		ZVAL_LONG(zu4R, (long)u4RRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBlowfishContext, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBlowfish, DecryptBlock)
{
	uint32_t u4LRaw;
	uint32_t u4RRaw;
	zval *oContext;
	zval *zu4L;
	zval *zu4R;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oContext, TSBBlowfishContext_ce_ptr, &zu4L, &zu4R) == SUCCESS) && PZVAL_IS_REF(oContext) && PZVAL_IS_REF(zu4L) && (IS_LONG == Z_TYPE_P(zu4L)) && PZVAL_IS_REF(zu4R) && (IS_LONG == Z_TYPE_P(zu4R)))
	{
		u4LRaw = (uint32_t)Z_LVAL_P(zu4L);
		u4RRaw = (uint32_t)Z_LVAL_P(zu4R);
		SBCheckError(SBBlowfish_DecryptBlock((TSBBlowfishContext *)SBGetStructPointer(oContext TSRMLS_CC), &u4LRaw, &u4RRaw) TSRMLS_CC);
		ZVAL_LONG(zu4L, (long)u4LRaw);
		ZVAL_LONG(zu4R, (long)u4RRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBlowfishContext, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBlowfish, Initialize)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TSBBlowfishContext_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBBlowfish_Initialize((TSBBlowfishContext *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBlowfishContext, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBlowfish, EksInitialize)
{
	long l4Rounds;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiSalt;
	zval *oContext;
	zval *zaKey;
	zval *zaSalt;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olzz", &oContext, TSBBlowfishContext_ce_ptr, &l4Rounds, &zaSalt, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBBlowfish_EksInitialize((TSBBlowfishContext *)SBGetStructPointer(oContext TSRMLS_CC), (int32_t)l4Rounds, aiSalt.data, aiSalt.len, aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSalt);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBlowfishContext, integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

