#include "sbbzip2types.h"

zend_class_entry *EState_ce_ptr = NULL;

SB_PHP_METHOD(EState, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(EState_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_EState___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry EState_methods[] = {
	PHP_ME(EState, __construct, arginfo_EState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_EState(TSRMLS_D)
{
	zend_class_entry ce;
	if (EState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "EState", EState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	EState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *DState_ce_ptr = NULL;

SB_PHP_METHOD(DState, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(DState_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_DState___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry DState_methods[] = {
	PHP_ME(DState, __construct, arginfo_DState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_DState(TSRMLS_D)
{
	zend_class_entry ce;
	if (DState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "DState", DState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	DState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *bz_stream_ce_ptr = NULL;

SB_PHP_METHOD(bz_stream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(bz_stream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_bz_stream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry bz_stream_methods[] = {
	PHP_ME(bz_stream, __construct, arginfo_bz_stream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_bz_stream(TSRMLS_D)
{
	zend_class_entry ce;
	if (bz_stream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "bz_stream", bz_stream_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	bz_stream_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBBzip2Types_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBBzip2Types, CRLF, SB_CRLF, SB_CRLF);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_HDR_B, SB_BZ_HDR_B, SB_BZ_HDR_B);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_HDR_Z, SB_BZ_HDR_Z, SB_BZ_HDR_Z);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_HDR_h, SB_BZ_HDR_h, SB_BZ_HDR_h);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_HDR_0, SB_BZ_HDR_0, SB_BZ_HDR_0);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_MAX_ALPHA_SIZE, SB_BZ_MAX_ALPHA_SIZE, SB_BZ_MAX_ALPHA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_MAX_CODE_LEN, SB_BZ_MAX_CODE_LEN, SB_BZ_MAX_CODE_LEN);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_RUNA, SB_BZ_RUNA, SB_BZ_RUNA);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_RUNB, SB_BZ_RUNB, SB_BZ_RUNB);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_GROUPS, SB_BZ_N_GROUPS, SB_BZ_N_GROUPS);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_G_SIZE, SB_BZ_G_SIZE, SB_BZ_G_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_ITERS, SB_BZ_N_ITERS, SB_BZ_N_ITERS);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_MAX_SELECTORS, SB_BZ_MAX_SELECTORS, SB_BZ_MAX_SELECTORS);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_LESSER_ICOST, SB_BZ_LESSER_ICOST, SB_BZ_LESSER_ICOST);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_GREATER_ICOST, SB_BZ_GREATER_ICOST, SB_BZ_GREATER_ICOST);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_RUN, SB_BZ_RUN, SB_BZ_RUN);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_FLUSH, SB_BZ_FLUSH, SB_BZ_FLUSH);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_FINISH, SB_BZ_FINISH, SB_BZ_FINISH);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_OK, SB_BZ_OK, SB_BZ_OK);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_RUN_OK, SB_BZ_RUN_OK, SB_BZ_RUN_OK);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_FLUSH_OK, SB_BZ_FLUSH_OK, SB_BZ_FLUSH_OK);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_FINISH_OK, SB_BZ_FINISH_OK, SB_BZ_FINISH_OK);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_STREAM_END, SB_BZ_STREAM_END, SB_BZ_STREAM_END);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_SEQUENCE_ERROR, SB_BZ_SEQUENCE_ERROR, SB_BZ_SEQUENCE_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_PARAM_ERROR, SB_BZ_PARAM_ERROR, SB_BZ_PARAM_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_MEM_ERROR, SB_BZ_MEM_ERROR, SB_BZ_MEM_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_DATA_ERROR, SB_BZ_DATA_ERROR, SB_BZ_DATA_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_DATA_ERROR_MAGIC, SB_BZ_DATA_ERROR_MAGIC, SB_BZ_DATA_ERROR_MAGIC);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_IO_ERROR, SB_BZ_IO_ERROR, SB_BZ_IO_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_UNEXPECTED_EOF, SB_BZ_UNEXPECTED_EOF, SB_BZ_UNEXPECTED_EOF);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_OUTBUFF_FULL, SB_BZ_OUTBUFF_FULL, SB_BZ_OUTBUFF_FULL);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_CONFIG_ERROR, SB_BZ_CONFIG_ERROR, SB_BZ_CONFIG_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_NULL, SB_BZ_NULL, SB_BZ_NULL);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_M_IDLE, SB_BZ_M_IDLE, SB_BZ_M_IDLE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_M_RUNNING, SB_BZ_M_RUNNING, SB_BZ_M_RUNNING);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_M_FLUSHING, SB_BZ_M_FLUSHING, SB_BZ_M_FLUSHING);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_M_FINISHING, SB_BZ_M_FINISHING, SB_BZ_M_FINISHING);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_S_OUTPUT, SB_BZ_S_OUTPUT, SB_BZ_S_OUTPUT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_S_INPUT, SB_BZ_S_INPUT, SB_BZ_S_INPUT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_RADIX, SB_BZ_N_RADIX, SB_BZ_N_RADIX);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_QSORT, SB_BZ_N_QSORT, SB_BZ_N_QSORT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_SHELL, SB_BZ_N_SHELL, SB_BZ_N_SHELL);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_N_OVERSHOOT, SB_BZ_N_OVERSHOOT, SB_BZ_N_OVERSHOOT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_IDLE, SB_BZ_X_IDLE, SB_BZ_X_IDLE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_OUTPUT, SB_BZ_X_OUTPUT, SB_BZ_X_OUTPUT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAGIC_1, SB_BZ_X_MAGIC_1, SB_BZ_X_MAGIC_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAGIC_2, SB_BZ_X_MAGIC_2, SB_BZ_X_MAGIC_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAGIC_3, SB_BZ_X_MAGIC_3, SB_BZ_X_MAGIC_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAGIC_4, SB_BZ_X_MAGIC_4, SB_BZ_X_MAGIC_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_1, SB_BZ_X_BLKHDR_1, SB_BZ_X_BLKHDR_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_2, SB_BZ_X_BLKHDR_2, SB_BZ_X_BLKHDR_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_3, SB_BZ_X_BLKHDR_3, SB_BZ_X_BLKHDR_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_4, SB_BZ_X_BLKHDR_4, SB_BZ_X_BLKHDR_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_5, SB_BZ_X_BLKHDR_5, SB_BZ_X_BLKHDR_5);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BLKHDR_6, SB_BZ_X_BLKHDR_6, SB_BZ_X_BLKHDR_6);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BCRC_1, SB_BZ_X_BCRC_1, SB_BZ_X_BCRC_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BCRC_2, SB_BZ_X_BCRC_2, SB_BZ_X_BCRC_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BCRC_3, SB_BZ_X_BCRC_3, SB_BZ_X_BCRC_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_BCRC_4, SB_BZ_X_BCRC_4, SB_BZ_X_BCRC_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_RANDBIT, SB_BZ_X_RANDBIT, SB_BZ_X_RANDBIT);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ORIGPTR_1, SB_BZ_X_ORIGPTR_1, SB_BZ_X_ORIGPTR_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ORIGPTR_2, SB_BZ_X_ORIGPTR_2, SB_BZ_X_ORIGPTR_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ORIGPTR_3, SB_BZ_X_ORIGPTR_3, SB_BZ_X_ORIGPTR_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAPPING_1, SB_BZ_X_MAPPING_1, SB_BZ_X_MAPPING_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MAPPING_2, SB_BZ_X_MAPPING_2, SB_BZ_X_MAPPING_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_SELECTOR_1, SB_BZ_X_SELECTOR_1, SB_BZ_X_SELECTOR_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_SELECTOR_2, SB_BZ_X_SELECTOR_2, SB_BZ_X_SELECTOR_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_SELECTOR_3, SB_BZ_X_SELECTOR_3, SB_BZ_X_SELECTOR_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CODING_1, SB_BZ_X_CODING_1, SB_BZ_X_CODING_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CODING_2, SB_BZ_X_CODING_2, SB_BZ_X_CODING_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CODING_3, SB_BZ_X_CODING_3, SB_BZ_X_CODING_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_1, SB_BZ_X_MTF_1, SB_BZ_X_MTF_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_2, SB_BZ_X_MTF_2, SB_BZ_X_MTF_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_3, SB_BZ_X_MTF_3, SB_BZ_X_MTF_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_4, SB_BZ_X_MTF_4, SB_BZ_X_MTF_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_5, SB_BZ_X_MTF_5, SB_BZ_X_MTF_5);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_MTF_6, SB_BZ_X_MTF_6, SB_BZ_X_MTF_6);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ENDHDR_2, SB_BZ_X_ENDHDR_2, SB_BZ_X_ENDHDR_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ENDHDR_3, SB_BZ_X_ENDHDR_3, SB_BZ_X_ENDHDR_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ENDHDR_4, SB_BZ_X_ENDHDR_4, SB_BZ_X_ENDHDR_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ENDHDR_5, SB_BZ_X_ENDHDR_5, SB_BZ_X_ENDHDR_5);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_ENDHDR_6, SB_BZ_X_ENDHDR_6, SB_BZ_X_ENDHDR_6);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CCRC_1, SB_BZ_X_CCRC_1, SB_BZ_X_CCRC_1);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CCRC_2, SB_BZ_X_CCRC_2, SB_BZ_X_CCRC_2);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CCRC_3, SB_BZ_X_CCRC_3, SB_BZ_X_CCRC_3);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_X_CCRC_4, SB_BZ_X_CCRC_4, SB_BZ_X_CCRC_4);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, MTFA_SIZE, SB_MTFA_SIZE, SB_MTFA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, MTFL_SIZE, SB_MTFL_SIZE, SB_MTFL_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, BZ_MAX_UNUSED, SB_BZ_MAX_UNUSED, SB_BZ_MAX_UNUSED);
	SB_REGISTER_LONG_CONSTANT(SBBzip2Types, NOFILE, SB_NOFILE, SB_NOFILE);
}

