#include "sbcompoundfilebase.h"

SB_PHP_METHOD(TSBCompoundFileHeader, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBCompoundFileHeader));
		intern->len = sizeof(TSBCompoundFileHeader);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBCompoundFileHeader, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBCompoundFileHeader));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBCompoundFileHeader, get_MinorVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_MinorVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_MajorVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_MajorVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_ByteOrder)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_ByteOrder)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_SectorShift)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 30);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_SectorShift)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 30);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_MiniSectorShift)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_MiniSectorShift)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_Reserved1)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_Reserved1)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_Reserved2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_Reserved2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_DirectorySectorsCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_DirectorySectorsCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_FATSectorsCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_FATSectorsCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_FirstDirectorySector)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_FirstDirectorySector)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_TransactionSignatureNumber)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_TransactionSignatureNumber)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_MiniStreamCutoffSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_MiniStreamCutoffSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_FirstMiniFATSector)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_FirstMiniFATSector)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_MiniFATSectorsCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_MiniFATSectorsCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_FirstDIFATSector)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_FirstDIFATSector)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TSBCompoundFileHeader, get_DIFATSectorsCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSBCompoundFileHeader, set_DIFATSectorsCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

zend_class_entry *TSBCompoundFileHeader_ce_ptr = NULL;

static zend_function_entry TSBCompoundFileHeader_methods[] = {
	PHP_ME(TSBCompoundFileHeader, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBCompoundFileHeader, get_MinorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_MinorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_MajorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_MajorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_ByteOrder, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_ByteOrder, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_SectorShift, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_SectorShift, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_MiniSectorShift, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_MiniSectorShift, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_Reserved1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_Reserved1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_Reserved2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_Reserved2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_DirectorySectorsCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_DirectorySectorsCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_FATSectorsCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_FATSectorsCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_FirstDirectorySector, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_FirstDirectorySector, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_TransactionSignatureNumber, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_TransactionSignatureNumber, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_MiniStreamCutoffSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_MiniStreamCutoffSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_FirstMiniFATSector, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_FirstMiniFATSector, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_MiniFATSectorsCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_MiniFATSectorsCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_FirstDIFATSector, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_FirstDIFATSector, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, get_DIFATSectorsCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileHeader, set_DIFATSectorsCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBCompoundFileHeader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBCompoundFileHeader_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBCompoundFileHeader", TSBCompoundFileHeader_methods);
	TSBCompoundFileHeader_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBCompoundFileDirectoryEntry));
		intern->len = sizeof(TSBCompoundFileDirectoryEntry);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBCompoundFileDirectoryEntry));
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_NameLength)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_NameLength)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_ObjectType)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 66);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_ObjectType)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 66);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_ColorFlag)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 67);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_ColorFlag)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 67);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_LeftSiblingID)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_LeftSiblingID)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_RightSiblingID)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_RightSiblingID)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_ChildID)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_ChildID)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_StateBits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_StateBits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_StartingSector)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_StartingSector)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, get_StreamSize)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

SB_PHP_METHOD(TSBCompoundFileDirectoryEntry, set_StreamSize)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

zend_class_entry *TSBCompoundFileDirectoryEntry_ce_ptr = NULL;

static zend_function_entry TSBCompoundFileDirectoryEntry_methods[] = {
	PHP_ME(TSBCompoundFileDirectoryEntry, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_NameLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_NameLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_ObjectType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_ObjectType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_ColorFlag, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_ColorFlag, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_LeftSiblingID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_LeftSiblingID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_RightSiblingID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_RightSiblingID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_ChildID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_ChildID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_StateBits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_StateBits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_StartingSector, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_StartingSector, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, get_StreamSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCompoundFileDirectoryEntry, set_StreamSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBCompoundFileDirectoryEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBCompoundFileDirectoryEntry_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBCompoundFileDirectoryEntry", TSBCompoundFileDirectoryEntry_methods);
	TSBCompoundFileDirectoryEntry_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCompoundFileBase_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_BASE, SB_CFB_ERROR_BASE, SB_CFB_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_WRITE_FAILED_READONLY, SB_CFB_ERROR_WRITE_FAILED_READONLY, SB_CFB_ERROR_WRITE_FAILED_READONLY);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_OUTPUT_BUFFER_TOO_SMALL, SB_CFB_ERROR_OUTPUT_BUFFER_TOO_SMALL, SB_CFB_ERROR_OUTPUT_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INPUT_BUFFER_TOO_SMALL, SB_CFB_ERROR_INPUT_BUFFER_TOO_SMALL, SB_CFB_ERROR_INPUT_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_DIFAT_READ_FAILED, SB_CFB_ERROR_DIFAT_READ_FAILED, SB_CFB_ERROR_DIFAT_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_DIFAT_WRITE_FAILED, SB_CFB_ERROR_DIFAT_WRITE_FAILED, SB_CFB_ERROR_DIFAT_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FAT_SECTOR_READ_FAILED, SB_CFB_ERROR_FAT_SECTOR_READ_FAILED, SB_CFB_ERROR_FAT_SECTOR_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FAT_SECTOR_WRITE_FAILED, SB_CFB_ERROR_FAT_SECTOR_WRITE_FAILED, SB_CFB_ERROR_FAT_SECTOR_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FAT_READ_FAILED, SB_CFB_ERROR_FAT_READ_FAILED, SB_CFB_ERROR_FAT_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FAT_WRITE_FAILED, SB_CFB_ERROR_FAT_WRITE_FAILED, SB_CFB_ERROR_FAT_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_FAT_SECTOR_READ_FAILED, SB_CFB_ERROR_MINI_FAT_SECTOR_READ_FAILED, SB_CFB_ERROR_MINI_FAT_SECTOR_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_FAT_SECTOR_WRITE_FAILED, SB_CFB_ERROR_MINI_FAT_SECTOR_WRITE_FAILED, SB_CFB_ERROR_MINI_FAT_SECTOR_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_FAT_READ_FAILED, SB_CFB_ERROR_MINI_FAT_READ_FAILED, SB_CFB_ERROR_MINI_FAT_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_FAT_WRITE_FAILED, SB_CFB_ERROR_MINI_FAT_WRITE_FAILED, SB_CFB_ERROR_MINI_FAT_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SECTOR_WRITE_FAILED, SB_CFB_ERROR_SECTOR_WRITE_FAILED, SB_CFB_ERROR_SECTOR_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FIRST_SECTOR_WRITE_FAILED, SB_CFB_ERROR_FIRST_SECTOR_WRITE_FAILED, SB_CFB_ERROR_FIRST_SECTOR_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_DIRECTORY_ENTRY_READ_FAILED, SB_CFB_ERROR_DIRECTORY_ENTRY_READ_FAILED, SB_CFB_ERROR_DIRECTORY_ENTRY_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_DIRECTORY_ENTRY_WRITE_FAILED, SB_CFB_ERROR_DIRECTORY_ENTRY_WRITE_FAILED, SB_CFB_ERROR_DIRECTORY_ENTRY_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_READ_FAILED, SB_CFB_ERROR_ROOT_ENTRY_READ_FAILED, SB_CFB_ERROR_ROOT_ENTRY_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_WRITE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_WRITE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_HEADER_READ_FAILED, SB_CFB_ERROR_HEADER_READ_FAILED, SB_CFB_ERROR_HEADER_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_HEADER_WRITE_FAILED, SB_CFB_ERROR_HEADER_WRITE_FAILED, SB_CFB_ERROR_HEADER_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_STREAM_READ_FAILED, SB_CFB_ERROR_MINI_STREAM_READ_FAILED, SB_CFB_ERROR_MINI_STREAM_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_MINI_STREAM_WRITE_FAILED, SB_CFB_ERROR_MINI_STREAM_WRITE_FAILED, SB_CFB_ERROR_MINI_STREAM_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_STREAM_READ_FAILED, SB_CFB_ERROR_STREAM_READ_FAILED, SB_CFB_ERROR_STREAM_READ_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_STREAM_WRITE_FAILED, SB_CFB_ERROR_STREAM_WRITE_FAILED, SB_CFB_ERROR_STREAM_WRITE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FAT_STREAM_RESIZE_FAILED, SB_CFB_ERROR_FAT_STREAM_RESIZE_FAILED, SB_CFB_ERROR_FAT_STREAM_RESIZE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_NO_STREAM_PARAMETER, SB_CFB_ERROR_NO_STREAM_PARAMETER, SB_CFB_ERROR_NO_STREAM_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_FILE_TOO_SMALL, SB_CFB_ERROR_FILE_TOO_SMALL, SB_CFB_ERROR_FILE_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_FILE_SIGNATURE, SB_CFB_ERROR_INVALID_FILE_SIGNATURE, SB_CFB_ERROR_INVALID_FILE_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_UNSUPPORTED_FILE_VERSION, SB_CFB_ERROR_UNSUPPORTED_FILE_VERSION, SB_CFB_ERROR_UNSUPPORTED_FILE_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_UNSUPPORTED_BYTE_ORDER, SB_CFB_ERROR_UNSUPPORTED_BYTE_ORDER, SB_CFB_ERROR_UNSUPPORTED_BYTE_ORDER);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_SECTOR_SIZE, SB_CFB_ERROR_INVALID_SECTOR_SIZE, SB_CFB_ERROR_INVALID_SECTOR_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_MINI_SECTOR_SIZE, SB_CFB_ERROR_INVALID_MINI_SECTOR_SIZE, SB_CFB_ERROR_INVALID_MINI_SECTOR_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_NUMBER_OF_DIFAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_DIFAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_DIFAT_SECTORS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_NUMBER_OF_FAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_FAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_FAT_SECTORS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_NUMBER_OF_MINI_FAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_MINI_FAT_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_MINI_FAT_SECTORS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_NUMBER_OF_DIRECTORY_ENTRY_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_DIRECTORY_ENTRY_SECTORS, SB_CFB_ERROR_INVALID_NUMBER_OF_DIRECTORY_ENTRY_SECTORS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_ROOT_ENTRY, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_ROOT_ENTRY, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_ROOT_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_DIRECTORY_ENTRY, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_DIRECTORY_ENTRY, SB_CFB_ERROR_INVALID_OBJECT_TYPE_FOR_DIRECTORY_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SID_EXCEEDS_MAX, SB_CFB_ERROR_SID_EXCEEDS_MAX, SB_CFB_ERROR_SID_EXCEEDS_MAX);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SID_ALREADY_IN_USE, SB_CFB_ERROR_SID_ALREADY_IN_USE, SB_CFB_ERROR_SID_ALREADY_IN_USE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SECTOR_EXCEEDS_MAX, SB_CFB_ERROR_SECTOR_EXCEEDS_MAX, SB_CFB_ERROR_SECTOR_EXCEEDS_MAX);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_CYCLIC_SECTOR, SB_CFB_ERROR_CYCLIC_SECTOR, SB_CFB_ERROR_CYCLIC_SECTOR);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_STREAM_NOT_FOUND, SB_CFB_ERROR_STREAM_NOT_FOUND, SB_CFB_ERROR_STREAM_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_STREAM_SIZE, SB_CFB_ERROR_INVALID_STREAM_SIZE, SB_CFB_ERROR_INVALID_STREAM_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_STREAM_SIZE_MISMATCH, SB_CFB_ERROR_STREAM_SIZE_MISMATCH, SB_CFB_ERROR_STREAM_SIZE_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_INVALID_DIRECTORY_ENTRY_NAME, SB_CFB_ERROR_INVALID_DIRECTORY_ENTRY_NAME, SB_CFB_ERROR_INVALID_DIRECTORY_ENTRY_NAME);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_DIRECTORY_ENTRY_NAME_EXISTS, SB_CFB_ERROR_DIRECTORY_ENTRY_NAME_EXISTS, SB_CFB_ERROR_DIRECTORY_ENTRY_NAME_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SUB_STORAGE_NOT_FOUND, SB_CFB_ERROR_SUB_STORAGE_NOT_FOUND, SB_CFB_ERROR_SUB_STORAGE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_SUB_STORAGE_NON_EMPTY, SB_CFB_ERROR_SUB_STORAGE_NON_EMPTY, SB_CFB_ERROR_SUB_STORAGE_NON_EMPTY);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_HAS_SIBLINGS, SB_CFB_ERROR_ROOT_ENTRY_HAS_SIBLINGS, SB_CFB_ERROR_ROOT_ENTRY_HAS_SIBLINGS);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_NAME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_NAME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_NAME_CHANGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_CREATION_TIME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_CREATION_TIME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_CREATION_TIME_CHANGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, SB_CFB_ERROR_ROOT_ENTRY_MODIFIED_TIME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_MODIFIED_TIME_CHANGE_FAILED, SB_CFB_ERROR_ROOT_ENTRY_MODIFIED_TIME_CHANGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, MAXREGSECT, SB_MAXREGSECT, SB_MAXREGSECT);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, DIFSECT, SB_DIFSECT, SB_DIFSECT);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, FATSECT, SB_FATSECT, SB_FATSECT);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, ENDOFCHAIN, SB_ENDOFCHAIN, SB_ENDOFCHAIN);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, FREESECT, SB_FREESECT, SB_FREESECT);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, MAXREGSID, SB_MAXREGSID, SB_MAXREGSID);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, NOSTREAM, SB_NOSTREAM, SB_NOSTREAM);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_INVALID, SB_STGTY_INVALID, SB_STGTY_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_STORAGE, SB_STGTY_STORAGE, SB_STGTY_STORAGE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_STREAM, SB_STGTY_STREAM, SB_STGTY_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_LOCKBYTES, SB_STGTY_LOCKBYTES, SB_STGTY_LOCKBYTES);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_PROPERTY, SB_STGTY_PROPERTY, SB_STGTY_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, STGTY_ROOT, SB_STGTY_ROOT, SB_STGTY_ROOT);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, DE_RED, SB_DE_RED, SB_DE_RED);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, DE_BLACK, SB_DE_BLACK, SB_DE_BLACK);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, CFB_HEADER_SIZE, SB_CFB_HEADER_SIZE, SB_CFB_HEADER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, CFB_DIR_ENTRY_SIZE, SB_CFB_DIR_ENTRY_SIZE, SB_CFB_DIR_ENTRY_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCompoundFileBase, CFB_DIR_ENTRY_MAX_NAME_LENGTH, SB_CFB_DIR_ENTRY_MAX_NAME_LENGTH, SB_CFB_DIR_ENTRY_MAX_NAME_LENGTH);
}

