#include "sbencoding.h"

SB_PHP_METHOD(TSBBase64Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBBase64Context));
		intern->len = sizeof(TSBBase64Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBBase64Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBBase64Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBBase64Context, get_TailBytes)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBBase64Context, set_TailBytes)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBBase64Context, get_LineWritten)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBBase64Context, set_LineWritten)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBBase64Context, get_LineSize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBBase64Context, set_LineSize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBBase64Context, get_EOLSize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBBase64Context, set_EOLSize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBBase64Context, get_EQUCount)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBBase64Context, set_EQUCount)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

zend_class_entry *TSBBase64Context_ce_ptr = NULL;

static zend_function_entry TSBBase64Context_methods[] = {
	PHP_ME(TSBBase64Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBBase64Context, get_TailBytes, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, set_TailBytes, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, get_LineWritten, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, set_LineWritten, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, get_LineSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, set_LineSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, get_EOLSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, set_EOLSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, get_EQUCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase64Context, set_EQUCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBBase64Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBBase64Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBBase64Context", TSBBase64Context_methods);
	TSBBase64Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBBase32Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBBase32Context));
		intern->len = sizeof(TSBBase32Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBBase32Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBBase32Context));
}

SB_PHP_METHOD(TSBBase32Context, get_TailSize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBBase32Context, set_TailSize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *TSBBase32Context_ce_ptr = NULL;

static zend_function_entry TSBBase32Context_methods[] = {
	PHP_ME(TSBBase32Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase32Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBBase32Context, get_TailSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBBase32Context, set_TailSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBBase32Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBBase32Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBBase32Context", TSBBase32Context_methods);
	TSBBase32Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBEncoding, B64EstimateEncodedSize)
{
	long l4InSize;
	zval *oCtx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oCtx, TSBBase64Context_ce_ptr, &l4InSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBEncoding_B64EstimateEncodedSize((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), (int32_t)l4InSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBase64Context, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64InitializeEncoding)
{
	long ffEOL;
	long l4LineSize;
	zend_bool bTrailingEOL;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ollb", &oCtx, TSBBase64Context_ce_ptr, &l4LineSize, &ffEOL, &bTrailingEOL) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBEncoding_B64InitializeEncoding((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), (int32_t)l4LineSize, (TSBEOLMarkerRaw)ffEOL, (int8_t)bTrailingEOL, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64InitializeDecoding)
{
	zend_bool bLiberalMode;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TSBBase64Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBEncoding_B64InitializeDecoding((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oCtx, TSBBase64Context_ce_ptr, &bLiberalMode) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBEncoding_B64InitializeDecoding_1((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), (int8_t)bLiberalMode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context) or (&TSBBase64Context, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64Encode)
{
	int32_t l4OutSizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oCtx;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozlzz", &oCtx, TSBBase64Context_ce_ptr, &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oCtx) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B64Encode((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64Decode)
{
	int32_t l4OutSizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oCtx;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozlzz", &oCtx, TSBBase64Context_ce_ptr, &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oCtx) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B64Decode((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64FinalizeEncoding)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *oCtx;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oCtx, TSBBase64Context_ce_ptr, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oCtx) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B64FinalizeEncoding((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B64FinalizeDecoding)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *oCtx;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oCtx, TSBBase64Context_ce_ptr, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oCtx) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B64FinalizeDecoding((TSBBase64Context *)SBGetStructPointer(oCtx TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase64Context, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64UnicodeDecode)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base64UnicodeDecode(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64Decode)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zend_bool bLiberalMode;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base64Decode(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bLiberalMode) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base64Decode_1(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bLiberalMode, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64Encode)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zend_bool bWrapLines;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bWrapLines) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base64Encode(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bWrapLines, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64EncodeString)
{
	char *sInText;
	int sInText_len;
	uint32_t _err;
	zend_bool bWrapLines;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sInText, &sInText_len, &bWrapLines) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_Base64EncodeString(sInText, (int32_t)sInText_len, (int8_t)bWrapLines, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1634586890, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64DecodeString)
{
	char *sInText;
	int sInText_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sInText, &sInText_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_Base64DecodeString(sInText, (int32_t)sInText_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-168055631, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64EncodeArray)
{
	SBArrayZValInfo aiInBuf;
	uint32_t _err;
	zend_bool bWrapLines;
	zval *zaInBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaInBuf, &bWrapLines) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBEncoding_Base64EncodeArray(aiInBuf.data, aiInBuf.len, (int8_t)bWrapLines, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(452873298, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base64DecodeArray)
{
	char *sInBuf;
	int sInBuf_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sInBuf, &sInBuf_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBEncoding_Base64DecodeArray(sInBuf, (int32_t)sInBuf_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(987937500, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32EstimateEncodedSize)
{
	long l4InSize;
	zval *oContext;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oContext, TSBBase32Context_ce_ptr, &l4InSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBEncoding_B32EstimateEncodedSize((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), (int32_t)l4InSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBase32Context, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32InitializeEncoding)
{
	zend_bool bUseExtendedAlphabet;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oContext, TSBBase32Context_ce_ptr, &bUseExtendedAlphabet) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBEncoding_B32InitializeEncoding((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), (int8_t)bUseExtendedAlphabet) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32Encode)
{
	int32_t l4OutSizeRaw;
	long l4Index;
	long l4OutIndex;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo aiOutBuffer;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zval *oContext;
	zval *zaBuffer;
	zval *zaOutBuffer;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozlzz", &oContext, TSBBase32Context_ce_ptr, &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B32Encode((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozllzlz", &oContext, TSBBase32Context_ce_ptr, &zaBuffer, &l4Index, &l4Size, &zaOutBuffer, &l4OutIndex, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBEncoding_B32Encode_1((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex, &l4OutSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1340161507, 4, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (&TSBBase32Context, array of byte|string|NULL, integer, integer, &array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32FinalizeEncoding)
{
	int32_t l4OutSizeRaw;
	long l4OutIndex;
	SBArrayZValInfo aiOutBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zval *oContext;
	zval *zaOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oContext, TSBBase32Context_ce_ptr, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B32FinalizeEncoding((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozlz", &oContext, TSBBase32Context_ce_ptr, &zaOutBuffer, &l4OutIndex, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBEncoding_B32FinalizeEncoding_1((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex, &l4OutSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(960089823, 1, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context, TSBPointer|array of byte|string|NULL, &integer) or (&TSBBase32Context, &array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32Encode)
{
	int32_t l4OutSizeRaw;
	long l4InIndex;
	long l4InSize;
	long l4OutIndex;
	SBArrayZValInfo aiInBuffer;
	SBArrayZValInfo aiOutBuffer;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	zval *zaInBuffer;
	zval *zaOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bUseExtendedAlphabet) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base32Encode(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bUseExtendedAlphabet, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzlzb", &zaInBuffer, &l4InIndex, &l4InSize, &zaOutBuffer, &l4OutIndex, &zl4OutSize, &bUseExtendedAlphabet) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuffer)) || (IS_ARRAY == Z_TYPE_P(zaInBuffer)) || (IS_NULL == Z_TYPE_P(zaInBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInBuffer, &aiInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBEncoding_Base32Encode_1(aiInBuffer.data, aiInBuffer.len, (int32_t)l4InIndex, (int32_t)l4InSize, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex, &l4OutSizeRaw, (int8_t)bUseExtendedAlphabet, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2091718458, 3, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool) or (array of byte|string|NULL, integer, integer, &array of byte|string, integer, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32EncodeBuffer)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaData, &bUseExtendedAlphabet) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBEncoding_Base32EncodeBuffer(aiData.data, aiData.len, (int8_t)bUseExtendedAlphabet, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-43335181, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32EncodeString)
{
	char *sData;
	int sData_len;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sData, &sData_len, &bUseExtendedAlphabet) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_Base32EncodeString(sData, (int32_t)sData_len, (int8_t)bUseExtendedAlphabet, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1426310981, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32EstimateDecodedSize)
{
	long l4InSize;
	zval *oContext;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oContext, TSBBase32Context_ce_ptr, &l4InSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBEncoding_B32EstimateDecodedSize((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), (int32_t)l4InSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBase32Context, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32InitializeDecoding)
{
	zend_bool bUseExtendedAlphabet;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oContext, TSBBase32Context_ce_ptr, &bUseExtendedAlphabet) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBEncoding_B32InitializeDecoding((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), (int8_t)bUseExtendedAlphabet) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32Decode)
{
	int32_t l4OutSizeRaw;
	long l4Index;
	long l4OutIndex;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo aiOutBuffer;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zval *oContext;
	zval *zaBuffer;
	zval *zaOutBuffer;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozlzz", &oContext, TSBBase32Context_ce_ptr, &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_B32Decode((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozllzlz", &oContext, TSBBase32Context_ce_ptr, &zaBuffer, &l4Index, &l4Size, &zaOutBuffer, &l4OutIndex, &zl4OutSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBEncoding_B32Decode_1((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex, &l4OutSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-888658432, 4, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (&TSBBase32Context, array of byte|string|NULL, integer, integer, &array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32Decode)
{
	int32_t l4OutSizeRaw;
	long l4InIndex;
	long l4InSize;
	long l4OutIndex;
	SBArrayZValInfo aiInBuffer;
	SBArrayZValInfo aiOutBuffer;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	zval *zaInBuffer;
	zval *zaOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bUseExtendedAlphabet) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBEncoding_Base32Decode(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bUseExtendedAlphabet, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzlzb", &zaInBuffer, &l4InIndex, &l4InSize, &zaOutBuffer, &l4OutIndex, &zl4OutSize, &bUseExtendedAlphabet) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuffer)) || (IS_ARRAY == Z_TYPE_P(zaInBuffer)) || (IS_NULL == Z_TYPE_P(zaInBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInBuffer, &aiInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBEncoding_Base32Decode_1(aiInBuffer.data, aiInBuffer.len, (int32_t)l4InIndex, (int32_t)l4InSize, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex, &l4OutSizeRaw, (int8_t)bUseExtendedAlphabet, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1956516538, 3, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool) or (array of byte|string|NULL, integer, integer, &array of byte|string, integer, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, B32FinalizeDecoding)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSBBase32Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBEncoding_B32FinalizeDecoding((TSBBase32Context *)SBGetStructPointer(oContext TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBBase32Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32DecodeBuffer)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaData, &bUseExtendedAlphabet) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBEncoding_Base32DecodeBuffer(aiData.data, aiData.len, (int8_t)bUseExtendedAlphabet, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1737615164, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32DecodeString)
{
	char *sData;
	int sData_len;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sData, &sData_len, &bUseExtendedAlphabet) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_Base32DecodeString(sData, (int32_t)sData_len, (int8_t)bUseExtendedAlphabet, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-973826053, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base32Extract)
{
	char *sData;
	int sData_len;
	long l4Size;
	long l4Start;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zend_bool bUseExtendedAlphabet;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllb", &zaData, &l4Start, &l4Size, &bUseExtendedAlphabet) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBEncoding_Base32Extract(aiData.data, aiData.len, (int32_t)l4Start, (int32_t)l4Size, (int8_t)bUseExtendedAlphabet, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1289600535, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllb", &sData, &sData_len, &l4Start, &l4Size, &bUseExtendedAlphabet) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_Base32Extract_1(sData, (int32_t)sData_len, (int32_t)l4Start, (int32_t)l4Size, (int8_t)bUseExtendedAlphabet, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1530993079, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, bool) or (string, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, URLEncode)
{
	char *sCharset;
	char *sData;
	int sCharset_len;
	int sData_len;
	uint32_t _err;
	zend_bool bEncodeSlash;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_URLEncode(sData, (int32_t)sData_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1746583145, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sData, &sData_len, &sCharset, &sCharset_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_URLEncode_1(sData, (int32_t)sData_len, sCharset, (int32_t)sCharset_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1295390874, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sData, &sData_len, &sCharset, &sCharset_len, &bEncodeSlash) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_URLEncode_2(sData, (int32_t)sData_len, sCharset, (int32_t)sCharset_len, (int8_t)bEncodeSlash, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-405798349, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, URLDecode)
{
	char *sCharset;
	char *sData;
	int sCharset_len;
	int sData_len;
	uint32_t _err;
	zend_bool bFormEncoded;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sData, &sData_len, &bFormEncoded) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_URLDecode(sData, (int32_t)sData_len, (int8_t)bFormEncoded, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1573117443, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sData, &sData_len, &sCharset, &sCharset_len, &bFormEncoded) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBEncoding_URLDecode_1(sData, (int32_t)sData_len, sCharset, (int32_t)sCharset_len, (int8_t)bFormEncoded, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1180530169, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBEncoding, Base16DecodeString)
{
	char *sData;
	int sData_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBEncoding_Base16DecodeString(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(938624788, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

void Register_SBEncoding_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBEncoding, BASE64_DECODE_OK, SB_BASE64_DECODE_OK, SB_BASE64_DECODE_OK);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, BASE64_DECODE_INVALID_CHARACTER, SB_BASE64_DECODE_INVALID_CHARACTER, SB_BASE64_DECODE_INVALID_CHARACTER);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, BASE64_DECODE_WRONG_DATA_SIZE, SB_BASE64_DECODE_WRONG_DATA_SIZE, SB_BASE64_DECODE_WRONG_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, BASE64_DECODE_NOT_ENOUGH_SPACE, SB_BASE64_DECODE_NOT_ENOUGH_SPACE, SB_BASE64_DECODE_NOT_ENOUGH_SPACE);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, base64PadByte, SB_base64PadByte, SB_base64PadByte);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, SB_BASE32_ERROR_BASE, SB_BASE32_ERROR_BASE, SB_BASE32_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, SB_BASE32_INVALID_DATA_SIZE, SB_BASE32_INVALID_DATA_SIZE, SB_BASE32_INVALID_DATA_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBEncoding, SB_BASE32_INVALID_DATA, SB_BASE32_INVALID_DATA, SB_BASE32_INVALID_DATA);
}

