#include "sbmath.h"

SB_PHP_METHOD(TRC4Random, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRC4Random));
		intern->len = sizeof(TRC4Random);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRC4Random, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRC4Random));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TRC4Random, get_I)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 256);
}

SB_PHP_METHOD(TRC4Random, set_I)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 256);
}

SB_PHP_METHOD(TRC4Random, get_J)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 260);
}

SB_PHP_METHOD(TRC4Random, set_J)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 260);
}

zend_class_entry *TRC4Random_ce_ptr = NULL;

static zend_function_entry TRC4Random_methods[] = {
	PHP_ME(TRC4Random, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Random, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TRC4Random, get_I, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Random, set_I, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Random, get_J, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Random, set_J, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TRC4Random(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRC4Random_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRC4Random", TRC4Random_methods);
	TRC4Random_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TRC4RandomContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRC4RandomContext));
		intern->len = sizeof(TRC4RandomContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRC4RandomContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRC4RandomContext));
}

SB_PHP_METHOD(TRC4RandomContext, get_I)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 256);
}

SB_PHP_METHOD(TRC4RandomContext, set_I)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 256);
}

SB_PHP_METHOD(TRC4RandomContext, get_J)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 260);
}

SB_PHP_METHOD(TRC4RandomContext, set_J)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 260);
}

zend_class_entry *TRC4RandomContext_ce_ptr = NULL;

static zend_function_entry TRC4RandomContext_methods[] = {
	PHP_ME(TRC4RandomContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4RandomContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TRC4RandomContext, get_I, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4RandomContext, set_I, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4RandomContext, get_J, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4RandomContext, set_J, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TRC4RandomContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRC4RandomContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRC4RandomContext", TRC4RandomContext_methods);
	TRC4RandomContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TSBMathProgressFuncRaw(void * _ObjectData, void * Data, int8_t * OutResult)
{
	zval **params[1];
	zval * zData;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zData);
	SBInitPointerObject(zData, Data TSRMLS_CC);

	params[0] = &zData;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zData);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

SB_PHP_METHOD(TLInt, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TLInt));
		intern->len = sizeof(TLInt);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TLInt, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TLInt));
}

SB_PHP_METHOD(TLInt, get_Length)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TLInt, set_Length)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *TLInt_ce_ptr = NULL;

static zend_function_entry TLInt_methods[] = {
	PHP_ME(TLInt, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TLInt, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TLInt, get_Length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TLInt, set_Length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TLInt(TSRMLS_D)
{
	zend_class_entry ce;
	if (TLInt_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TLInt", TLInt_methods);
	TLInt_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBMath, LShl)
{
	TLInt * proNum;
	zval *oNum;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oNum, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oNum))
	{
		proNum = (TLInt *)SBGetStructPointer(oNum TSRMLS_CC);
		SBCheckError(SBMath_LShl(&proNum) TSRMLS_CC);
		SBSetStructPointer(oNum, proNum, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShlEx)
{
	long l4Bits;
	TLInt * proNum;
	zval *oNum;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oNum, TLInt_ce_ptr, &l4Bits) == SUCCESS) && PZVAL_IS_REF(oNum))
	{
		proNum = (TLInt *)SBGetStructPointer(oNum TSRMLS_CC);
		SBCheckError(SBMath_LShlEx(&proNum, (int32_t)l4Bits) TSRMLS_CC);
		SBSetStructPointer(oNum, proNum, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShlNum)
{
	long l4Bits;
	zval *oDest;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSrc, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &l4Bits) == SUCCESS)
	{
		SBCheckError(SBMath_LShlNum((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShr)
{
	TLInt * proNum;
	zval *oNum;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oNum, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oNum))
	{
		proNum = (TLInt *)SBGetStructPointer(oNum TSRMLS_CC);
		SBCheckError(SBMath_LShr(&proNum) TSRMLS_CC);
		SBSetStructPointer(oNum, proNum, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShrEx)
{
	long l4Bits;
	TLInt * proNum;
	zval *oNum;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oNum, TLInt_ce_ptr, &l4Bits) == SUCCESS) && PZVAL_IS_REF(oNum))
	{
		proNum = (TLInt *)SBGetStructPointer(oNum TSRMLS_CC);
		SBCheckError(SBMath_LShrEx(&proNum, (int32_t)l4Bits) TSRMLS_CC);
		SBSetStructPointer(oNum, proNum, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShrNum)
{
	long u4Bits;
	TLInt * proRes;
	zval *oRes;
	zval *oX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!Ol", &oX, TLInt_ce_ptr, &oRes, TLInt_ce_ptr, &u4Bits) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LShrNum((TLInt *)SBGetStructPointer(oX TSRMLS_CC), &proRes, (uint32_t)u4Bits) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LShiftLeft)
{
	long u4N;
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oA, TLInt_ce_ptr, &u4N) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LShiftLeft(&proA, (uint32_t)u4N) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LAdd)
{
	long u4B;
	zval *oA;
	zval *oB;
	zval *oC;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBMath_LAdd((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oC TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oA, TLInt_ce_ptr, &u4B, &oC, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBMath_LAdd_1((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (uint32_t)u4B, (TLInt *)SBGetStructPointer(oC TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt) or (TLInt, integer, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LSub)
{
	long u4B;
	TLInt * proPTm;
	zval *oA;
	zval *oB;
	zval *oPTm;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oPTm, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oPTm))
	{
		proPTm = (TLInt *)SBGetStructPointer(oPTm TSRMLS_CC);
		SBCheckError(SBMath_LSub((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &proPTm) TSRMLS_CC);
		SBSetStructPointer(oPTm, proPTm, sizeof(TLInt) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO", &oA, TLInt_ce_ptr, &u4B, &oPTm, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oPTm))
	{
		proPTm = (TLInt *)SBGetStructPointer(oPTm TSRMLS_CC);
		SBCheckError(SBMath_LSub_1((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (uint32_t)u4B, &proPTm) TSRMLS_CC);
		SBSetStructPointer(oPTm, proPTm, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt) or (TLInt, integer, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LDec)
{
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LDec(&proA) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LInc)
{
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LInc(&proA) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMultSh)
{
	long u4B;
	zval *oA;
	zval *oRes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oA, TLInt_ce_ptr, &u4B, &oRes, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBMath_LMultSh((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (uint32_t)u4B, (TLInt *)SBGetStructPointer(oRes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMult)
{
	TLInt * proRes;
	zval *oA;
	zval *oB;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LMult((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LModSh)
{
	long u4B;
	uint32_t u4ResRaw;
	zval *oA;
	zval *zu4Res;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lz", &oA, TLInt_ce_ptr, &u4B, &zu4Res) == SUCCESS) && PZVAL_IS_REF(zu4Res) && (IS_LONG == Z_TYPE_P(zu4Res)))
	{
		u4ResRaw = (uint32_t)Z_LVAL_P(zu4Res);
		SBCheckError(SBMath_LModSh((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (uint32_t)u4B, &u4ResRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Res, (long)u4ResRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMod)
{
	TLInt * proRes;
	zval *oN;
	zval *oRes;
	zval *oX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oX, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LMod((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LModEx)
{
	TLInt * proRes;
	zval *oN;
	zval *oRes;
	zval *oX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oX, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LModEx((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LDivSh)
{
	long u4B;
	zval *oA;
	zval *oQ;
	zval *oR;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!O!", &oA, TLInt_ce_ptr, &u4B, &oQ, TLInt_ce_ptr, &oR, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBMath_LDivSh((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (uint32_t)u4B, (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oR TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LDiv)
{
	TLInt * proC;
	TLInt * proD;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oD;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!OO", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &oD, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC) && PZVAL_IS_REF(oD))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		proD = (TLInt *)SBGetStructPointer(oD TSRMLS_CC);
		SBCheckError(SBMath_LDiv((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &proC, &proD) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oD, proD, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LModPower)
{
	TLInt * proRes;
	zval *oA;
	zval *oE;
	zval *oN;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oE, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LModPower((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oE TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMontgomery)
{
	TLInt * proRes;
	zval *oA;
	zval *oB;
	zval *oN;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LMontgomery((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LGCD)
{
	TLInt * proC;
	TLInt * proD;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oD;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!OO", &oB, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &oD, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC) && PZVAL_IS_REF(oD))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		proD = (TLInt *)SBGetStructPointer(oD TSRMLS_CC);
		SBCheckError(SBMath_LGCD((TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &proC, &proD) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oD, proD, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LSwap)
{
	TLInt * proA;
	TLInt * proB;
	zval *oA;
	zval *oB;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA) && PZVAL_IS_REF(oB))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		proB = (TLInt *)SBGetStructPointer(oB TSRMLS_CC);
		SBCheckError(SBMath_LSwap(&proA, &proB) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oB, proB, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBitCount)
{
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oA, TLInt_ce_ptr) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBMath_LBitCount((TLInt *)SBGetStructPointer(oA TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBitSet)
{
	long l4n;
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oA, TLInt_ce_ptr, &l4n) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBMath_LBitSet((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (int32_t)l4n, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LSetBit)
{
	long l4n;
	TLInt * proA;
	zend_bool bValue;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olb", &oA, TLInt_ce_ptr, &l4n, &bValue) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LSetBit(&proA, (int32_t)l4n, (int8_t)bValue) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBitTruncate)
{
	long l4Bits;
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oA, TLInt_ce_ptr, &l4Bits) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LBitTruncate(&proA, (int32_t)l4Bits) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LGreater)
{
	zval *oA;
	zval *oB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBMath_LGreater((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LEqual)
{
	zval *oA;
	zval *oB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBMath_LEqual((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LEven)
{
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oA, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBMath_LEven((TLInt *)SBGetStructPointer(oA TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LNull)
{
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oA, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBMath_LNull((TLInt *)SBGetStructPointer(oA TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LCopy)
{
	TLInt * proP;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBMath_LCopy(&proP, (TLInt *)SBGetStructPointer(oA TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LZero)
{
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LZero(&proA) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LToStr)
{
	uint32_t _err;
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oA, TLInt_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBMath_LToStr((TLInt *)SBGetStructPointer(oA TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1181400013, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LToBase64)
{
	uint32_t _err;
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oA, TLInt_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBMath_LToBase64((TLInt *)SBGetStructPointer(oA TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1591964350, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LInit)
{
	char *sNum;
	int sNum_len;
	long l8Num;
	long u4Num;
	TLInt * proP;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oP, TLInt_ce_ptr, &sNum, &sNum_len) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBMath_LInit(&proP, sNum, (int32_t)sNum_len) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oP, TLInt_ce_ptr, &u4Num) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBMath_LInit_1(&proP, (uint32_t)u4Num) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oP, TLInt_ce_ptr, &l8Num) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBMath_LInit_2(&proP, (int64_t)l8Num) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, string) or (&TLInt, integer) or (&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LGenerate)
{
	long l4Len;
	TLInt * proR;
	zval *oR;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oR, TLInt_ce_ptr, &l4Len) == SUCCESS) && PZVAL_IS_REF(oR))
	{
		proR = (TLInt *)SBGetStructPointer(oR TSRMLS_CC);
		SBCheckError(SBMath_LGenerate(&proR, (int32_t)l4Len) TSRMLS_CC);
		SBSetStructPointer(oR, proR, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LCreate)
{
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LCreate(&proA) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LDestroy)
{
	TLInt * proP;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oP, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBMath_LDestroy(&proP) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LTrim)
{
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LTrim(&proA) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LSanitize)
{
	long l4Digits;
	TLInt * proA;
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oA, TLInt_ce_ptr, &l4Digits) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBMath_LSanitize(&proA, (int32_t)l4Digits) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, HexToDecDigit)
{
	char *cA;
	int cA_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cA, &cA_len) == SUCCESS) && (1 == cA_len))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBMath_HexToDecDigit(cA[0], &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, DecToHexDigit)
{
	long l4A;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4A) == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(SBMath_DecToHexDigit((int32_t)l4A, &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, DecToHex)
{
	long u4A;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4A) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBMath_DecToHex((uint32_t)u4A, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1759151854, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBAddPowB)
{
	long u4Bases;
	zval *oDest;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSrc, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4Bases) == SUCCESS)
	{
		SBCheckError(SBMath_LBAddPowB((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (uint32_t)u4Bases) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBM)
{
	long u4Bits;
	zval *oDest;
	zval *oSrcMod;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSrcMod, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4Bits) == SUCCESS)
	{
		SBCheckError(SBMath_LBM((TLInt *)SBGetStructPointer(oSrcMod TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (uint32_t)u4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBDivPowB)
{
	long u4Bases;
	zval *oDest;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSrc, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4Bases) == SUCCESS)
	{
		SBCheckError(SBMath_LBDivPowB((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (uint32_t)u4Bases) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBModPowB)
{
	long u4Bases;
	zval *oDest;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSrc, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4Bases) == SUCCESS)
	{
		SBCheckError(SBMath_LBModPowB((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (uint32_t)u4Bases) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBMul)
{
	long u4FromBases;
	long u4ToBases;
	zval *oDest;
	zval *oSrcA;
	zval *oSrcB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!ll", &oSrcA, TLInt_ce_ptr, &oSrcB, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4FromBases, &u4ToBases) == SUCCESS)
	{
		SBCheckError(SBMath_LBMul((TLInt *)SBGetStructPointer(oSrcA TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrcB TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), (uint32_t)u4FromBases, (uint32_t)u4ToBases) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBMod)
{
	long u4Bits;
	TLInt * proDest;
	zval *oDest;
	zval *oSrc;
	zval *oSrcM;
	zval *oSrcMod;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!Ol", &oSrc, TLInt_ce_ptr, &oSrcMod, TLInt_ce_ptr, &oSrcM, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &u4Bits) == SUCCESS) && PZVAL_IS_REF(oDest))
	{
		proDest = (TLInt *)SBGetStructPointer(oDest TSRMLS_CC);
		SBCheckError(SBMath_LBMod((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrcMod TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrcM TSRMLS_CC), &proDest, (uint32_t)u4Bits) TSRMLS_CC);
		SBSetStructPointer(oDest, proDest, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LBPowMod)
{
	TLInt * proDest;
	zval *oDest;
	zval *oModInv;
	zval *oSrcA;
	zval *oSrcB;
	zval *oSrcMod;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!OO!", &oSrcA, TLInt_ce_ptr, &oSrcB, TLInt_ce_ptr, &oSrcMod, TLInt_ce_ptr, &oDest, TLInt_ce_ptr, &oModInv, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDest))
	{
		proDest = (TLInt *)SBGetStructPointer(oDest TSRMLS_CC);
		SBCheckError(SBMath_LBPowMod((TLInt *)SBGetStructPointer(oSrcA TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrcB TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrcMod TSRMLS_CC), &proDest, (TLInt *)SBGetStructPointer(oModInv TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oDest, proDest, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMMul)
{
	TLInt * proRes;
	zval *oA;
	zval *oB;
	zval *oN;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oRes))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		SBCheckError(SBMath_LMMul((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LMModPower)
{
	SBArrayZValInfo piData;
	TLInt * proRes;
	void *pzProgressFunc;
	zend_bool bRaiseExceptionOnCancel;
	zval *oE;
	zval *oN;
	zval *oRes;
	zval *oX;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!Ozzb", &oX, TLInt_ce_ptr, &oE, TLInt_ce_ptr, &oN, TLInt_ce_ptr, &oRes, TLInt_ce_ptr, &zProgressFunc, &zpData, &bRaiseExceptionOnCancel) == SUCCESS) && PZVAL_IS_REF(oRes) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		proRes = (TLInt *)SBGetStructPointer(oRes TSRMLS_CC);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_LMModPower((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oE TSRMLS_CC), (TLInt *)SBGetStructPointer(oN TSRMLS_CC), &proRes, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, (int8_t)bRaiseExceptionOnCancel) TSRMLS_CC);
		SBSetStructPointer(oRes, proRes, sizeof(TLInt) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LRabinMillerPrimeTest)
{
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zend_bool bRaiseExceptionOnCancel;
	zval *oP;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzb", &oP, TLInt_ce_ptr, &zProgressFunc, &zpData, &bRaiseExceptionOnCancel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_LRabinMillerPrimeTest((TLInt *)SBGetStructPointer(oP TSRMLS_CC), pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, (int8_t)bRaiseExceptionOnCancel, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LIsPrime)
{
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zend_bool bRaiseExceptionOnCancel;
	zval *oP;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzb", &oP, TLInt_ce_ptr, &zProgressFunc, &zpData, &bRaiseExceptionOnCancel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_LIsPrime((TLInt *)SBGetStructPointer(oP TSRMLS_CC), pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, (int8_t)bRaiseExceptionOnCancel, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LGenPrime)
{
	long l4Len;
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zend_bool bRaiseExceptionOnCancel;
	zend_bool bRSAPrime;
	zval *oP;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbzzb", &oP, TLInt_ce_ptr, &l4Len, &bRSAPrime, &zProgressFunc, &zpData, &bRaiseExceptionOnCancel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_LGenPrime((TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Len, (int8_t)bRSAPrime, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, (int8_t)bRaiseExceptionOnCancel) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer, bool, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LGenPrimeEx)
{
	long l4Bits;
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zend_bool bRaiseExceptionOnCancel;
	zend_bool bRSAPrime;
	zval *oP;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbzzb", &oP, TLInt_ce_ptr, &l4Bits, &bRSAPrime, &zProgressFunc, &zpData, &bRaiseExceptionOnCancel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_LGenPrimeEx((TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Bits, (int8_t)bRSAPrime, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, (int8_t)bRaiseExceptionOnCancel) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer, bool, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LRC4Randomize)
{
	zval *oCtx;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oCtx, TRC4RandomContext_ce_ptr, &oKey, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		SBCheckError(SBMath_LRC4Randomize((TRC4RandomContext *)SBGetStructPointer(oCtx TSRMLS_CC), (TLInt *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4RandomContext, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LRC4Init)
{
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TRC4RandomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		SBCheckError(SBMath_LRC4Init((TRC4RandomContext *)SBGetStructPointer(oCtx TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4RandomContext)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LRC4RandomByte)
{
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TRC4RandomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(SBMath_LRC4RandomByte((TRC4RandomContext *)SBGetStructPointer(oCtx TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4RandomContext)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, LRandom)
{
	long l4Bytes;
	zval *oA;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!l", &oCtx, TRC4RandomContext_ce_ptr, &oA, TLInt_ce_ptr, &l4Bytes) == SUCCESS) && PZVAL_IS_REF(oCtx))
	{
		SBCheckError(SBMath_LRandom((TRC4RandomContext *)SBGetStructPointer(oCtx TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (int32_t)l4Bytes) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4RandomContext, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMath, MathOperationCanceled)
{
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zProgressFunc, &zpData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMath_MathOperationCanceled(pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBMath_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBMath, MAXDIGIT, SB_MAXDIGIT, SB_MAXDIGIT);
	SB_REGISTER_LONG_CONSTANT(SBMath, RandKeyLength, SB_RandKeyLength, SB_RandKeyLength);
	SB_REGISTER_STRING_CONSTANT(SBMath, sNumberTooLarge, SB_sNumberTooLarge, SB_sNumberTooLarge);
	SB_REGISTER_STRING_CONSTANT(SBMath, sDivisionByZero, SB_sDivisionByZero, SB_sDivisionByZero);
}

