#include "sbpkcs11common.h"

SB_PHP_METHOD(TPKCS11FuncArray, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11FuncArray));
		intern->len = sizeof(TPKCS11FuncArray);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11FuncArray, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11FuncArray));
}

zend_class_entry *TPKCS11FuncArray_ce_ptr = NULL;

static zend_function_entry TPKCS11FuncArray_methods[] = {
	PHP_ME(TPKCS11FuncArray, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11FuncArray, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPKCS11FuncArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11FuncArray_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11FuncArray", TPKCS11FuncArray_methods);
	TPKCS11FuncArray_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CK_SLOT_ID_ARRAY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CK_SLOT_ID_ARRAY));
		intern->len = sizeof(SB_CK_SLOT_ID_ARRAY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CK_SLOT_ID_ARRAY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CK_SLOT_ID_ARRAY));
}

zend_class_entry *SB_CK_SLOT_ID_ARRAY_ce_ptr = NULL;

static zend_function_entry SB_CK_SLOT_ID_ARRAY_methods[] = {
	PHP_ME(SB_CK_SLOT_ID_ARRAY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_SLOT_ID_ARRAY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_CK_SLOT_ID_ARRAY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CK_SLOT_ID_ARRAY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CK_SLOT_ID_ARRAY", SB_CK_SLOT_ID_ARRAY_methods);
	SB_CK_SLOT_ID_ARRAY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CK_OBJECT_HANDLE_ARRAY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CK_OBJECT_HANDLE_ARRAY));
		intern->len = sizeof(SB_CK_OBJECT_HANDLE_ARRAY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CK_OBJECT_HANDLE_ARRAY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CK_OBJECT_HANDLE_ARRAY));
}

zend_class_entry *SB_CK_OBJECT_HANDLE_ARRAY_ce_ptr = NULL;

static zend_function_entry SB_CK_OBJECT_HANDLE_ARRAY_methods[] = {
	PHP_ME(SB_CK_OBJECT_HANDLE_ARRAY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_OBJECT_HANDLE_ARRAY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_CK_OBJECT_HANDLE_ARRAY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CK_OBJECT_HANDLE_ARRAY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CK_OBJECT_HANDLE_ARRAY", SB_CK_OBJECT_HANDLE_ARRAY_methods);
	SB_CK_OBJECT_HANDLE_ARRAY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11Version, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11Version));
		intern->len = sizeof(TPKCS11Version);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11Version, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11Version));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TPKCS11Version, get_Major)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPKCS11Version, set_Major)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPKCS11Version, get_Minor)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TPKCS11Version, set_Minor)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

zend_class_entry *TPKCS11Version_ce_ptr = NULL;

static zend_function_entry TPKCS11Version_methods[] = {
	PHP_ME(TPKCS11Version, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Version, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11Version, get_Major, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Version, set_Major, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Version, get_Minor, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Version, set_Minor, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11Version(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11Version_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11Version", TPKCS11Version_methods);
	TPKCS11Version_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11FunctionList, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11FunctionList));
		intern->len = sizeof(TPKCS11FunctionList);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11FunctionList, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11FunctionList));
}

zend_class_entry *TPKCS11FunctionList_ce_ptr = NULL;

static zend_function_entry TPKCS11FunctionList_methods[] = {
	PHP_ME(TPKCS11FunctionList, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11FunctionList, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPKCS11FunctionList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11FunctionList_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11FunctionList", TPKCS11FunctionList_methods);
	TPKCS11FunctionList_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11InitializeArgs, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11InitializeArgs));
		intern->len = sizeof(TPKCS11InitializeArgs);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11InitializeArgs, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11InitializeArgs));
}

SB_PHP_METHOD(TPKCS11InitializeArgs, get_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(TPKCS11InitializeArgs, set_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

zend_class_entry *TPKCS11InitializeArgs_ce_ptr = NULL;

static zend_function_entry TPKCS11InitializeArgs_methods[] = {
	PHP_ME(TPKCS11InitializeArgs, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11InitializeArgs, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11InitializeArgs, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11InitializeArgs, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11InitializeArgs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11InitializeArgs_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11InitializeArgs", TPKCS11InitializeArgs_methods);
	TPKCS11InitializeArgs_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11InitializeArgsNSS, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11InitializeArgsNSS));
		intern->len = sizeof(TPKCS11InitializeArgsNSS);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11InitializeArgsNSS, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11InitializeArgsNSS));
}

SB_PHP_METHOD(TPKCS11InitializeArgsNSS, get_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(TPKCS11InitializeArgsNSS, set_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

zend_class_entry *TPKCS11InitializeArgsNSS_ce_ptr = NULL;

static zend_function_entry TPKCS11InitializeArgsNSS_methods[] = {
	PHP_ME(TPKCS11InitializeArgsNSS, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11InitializeArgsNSS, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11InitializeArgsNSS, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11InitializeArgsNSS, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11InitializeArgsNSS(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11InitializeArgsNSS_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11InitializeArgsNSS", TPKCS11InitializeArgsNSS_methods);
	TPKCS11InitializeArgsNSS_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11Info, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11Info));
		intern->len = sizeof(TPKCS11Info);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11Info, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11Info));
}

SB_PHP_METHOD(TPKCS11Info, get_flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(TPKCS11Info, set_flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

zend_class_entry *TPKCS11Info_ce_ptr = NULL;

static zend_function_entry TPKCS11Info_methods[] = {
	PHP_ME(TPKCS11Info, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Info, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11Info, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Info, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11Info(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11Info_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11Info", TPKCS11Info_methods);
	TPKCS11Info_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11SlotInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11SlotInfo));
		intern->len = sizeof(TPKCS11SlotInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11SlotInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11SlotInfo));
}

SB_PHP_METHOD(TPKCS11SlotInfo, get_flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TPKCS11SlotInfo, set_flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

zend_class_entry *TPKCS11SlotInfo_ce_ptr = NULL;

static zend_function_entry TPKCS11SlotInfo_methods[] = {
	PHP_ME(TPKCS11SlotInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SlotInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11SlotInfo, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SlotInfo, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11SlotInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11SlotInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11SlotInfo", TPKCS11SlotInfo_methods);
	TPKCS11SlotInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11TokenInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11TokenInfo));
		intern->len = sizeof(TPKCS11TokenInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11TokenInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11TokenInfo));
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulMaxSessionCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulMaxSessionCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulSessionCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulSessionCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulMaxRwSessionCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 108);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulMaxRwSessionCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 108);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulRwSessionCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 112);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulRwSessionCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 112);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulMaxPinLen)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulMaxPinLen)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulMinPinLen)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulMinPinLen)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulTotalPublicMemory)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 124);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulTotalPublicMemory)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 124);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulFreePublicMemory)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 128);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulFreePublicMemory)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 128);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulTotalPrivateMemory)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 132);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulTotalPrivateMemory)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 132);
}

SB_PHP_METHOD(TPKCS11TokenInfo, get_ulFreePrivateMemory)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

SB_PHP_METHOD(TPKCS11TokenInfo, set_ulFreePrivateMemory)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

zend_class_entry *TPKCS11TokenInfo_ce_ptr = NULL;

static zend_function_entry TPKCS11TokenInfo_methods[] = {
	PHP_ME(TPKCS11TokenInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11TokenInfo, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulMaxSessionCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulMaxSessionCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulSessionCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulSessionCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulMaxRwSessionCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulMaxRwSessionCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulRwSessionCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulRwSessionCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulMaxPinLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulMaxPinLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulMinPinLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulMinPinLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulTotalPublicMemory, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulTotalPublicMemory, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulFreePublicMemory, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulFreePublicMemory, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulTotalPrivateMemory, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulTotalPrivateMemory, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, get_ulFreePrivateMemory, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11TokenInfo, set_ulFreePrivateMemory, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11TokenInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11TokenInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11TokenInfo", TPKCS11TokenInfo_methods);
	TPKCS11TokenInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11SessionInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11SessionInfo));
		intern->len = sizeof(TPKCS11SessionInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11SessionInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11SessionInfo));
}

SB_PHP_METHOD(TPKCS11SessionInfo, get_slotID)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, set_slotID)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, get_state)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, set_state)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, get_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, set_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, get_ulDeviceError)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
#endif
}

SB_PHP_METHOD(TPKCS11SessionInfo, set_ulDeviceError)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
#endif
}

zend_class_entry *TPKCS11SessionInfo_ce_ptr = NULL;

static zend_function_entry TPKCS11SessionInfo_methods[] = {
	PHP_ME(TPKCS11SessionInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11SessionInfo, get_slotID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, set_slotID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, get_state, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, set_state, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, get_ulDeviceError, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11SessionInfo, set_ulDeviceError, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11SessionInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11SessionInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11SessionInfo", TPKCS11SessionInfo_methods);
	TPKCS11SessionInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11Attribute, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11Attribute));
		intern->len = sizeof(TPKCS11Attribute);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11Attribute, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11Attribute));
}

SB_PHP_METHOD(TPKCS11Attribute, get__type)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11Attribute, set__type)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11Attribute, get_ulValueLen)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

SB_PHP_METHOD(TPKCS11Attribute, set_ulValueLen)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

zend_class_entry *TPKCS11Attribute_ce_ptr = NULL;

static zend_function_entry TPKCS11Attribute_methods[] = {
	PHP_ME(TPKCS11Attribute, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Attribute, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11Attribute, get__type, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Attribute, set__type, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Attribute, get_ulValueLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11Attribute, set_ulValueLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11Attribute(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11Attribute_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11Attribute", TPKCS11Attribute_methods);
	TPKCS11Attribute_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CK_ATTRIBUTE_ARRAY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CK_ATTRIBUTE_ARRAY));
		intern->len = sizeof(SB_CK_ATTRIBUTE_ARRAY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CK_ATTRIBUTE_ARRAY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CK_ATTRIBUTE_ARRAY));
}

zend_class_entry *SB_CK_ATTRIBUTE_ARRAY_ce_ptr = NULL;

static zend_function_entry SB_CK_ATTRIBUTE_ARRAY_methods[] = {
	PHP_ME(SB_CK_ATTRIBUTE_ARRAY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_ATTRIBUTE_ARRAY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_CK_ATTRIBUTE_ARRAY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CK_ATTRIBUTE_ARRAY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CK_ATTRIBUTE_ARRAY", SB_CK_ATTRIBUTE_ARRAY_methods);
	SB_CK_ATTRIBUTE_ARRAY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CK_MECHANISM, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CK_MECHANISM));
		intern->len = sizeof(SB_CK_MECHANISM);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CK_MECHANISM, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CK_MECHANISM));
}

SB_PHP_METHOD(SB_CK_MECHANISM, get_mechanism)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(SB_CK_MECHANISM, set_mechanism)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(SB_CK_MECHANISM, get_ulParameterLen)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

SB_PHP_METHOD(SB_CK_MECHANISM, set_ulParameterLen)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

zend_class_entry *SB_CK_MECHANISM_ce_ptr = NULL;

static zend_function_entry SB_CK_MECHANISM_methods[] = {
	PHP_ME(SB_CK_MECHANISM, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_MECHANISM, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_CK_MECHANISM, get_mechanism, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_MECHANISM, set_mechanism, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_MECHANISM, get_ulParameterLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CK_MECHANISM, set_ulParameterLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_CK_MECHANISM(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CK_MECHANISM_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CK_MECHANISM", SB_CK_MECHANISM_methods);
	SB_CK_MECHANISM_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPKCS11MechanismInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPKCS11MechanismInfo));
		intern->len = sizeof(TPKCS11MechanismInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPKCS11MechanismInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPKCS11MechanismInfo));
}

SB_PHP_METHOD(TPKCS11MechanismInfo, get_ulMinKeySize)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11MechanismInfo, set_ulMinKeySize)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#endif
}

SB_PHP_METHOD(TPKCS11MechanismInfo, get_ulMaxKeySize)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(TPKCS11MechanismInfo, set_ulMaxKeySize)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(TPKCS11MechanismInfo, get_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(TPKCS11MechanismInfo, set_flags)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

zend_class_entry *TPKCS11MechanismInfo_ce_ptr = NULL;

static zend_function_entry TPKCS11MechanismInfo_methods[] = {
	PHP_ME(TPKCS11MechanismInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPKCS11MechanismInfo, get_ulMinKeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, set_ulMinKeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, get_ulMaxKeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, set_ulMaxKeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPKCS11MechanismInfo, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPKCS11MechanismInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPKCS11MechanismInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPKCS11MechanismInfo", TPKCS11MechanismInfo_methods);
	TPKCS11MechanismInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPKCS11Common_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_FUNC_FIRST, SB_PKCS11_FUNC_FIRST, SB_PKCS11_FUNC_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Initialize, SB_PKCS11_Initialize, SB_PKCS11_Initialize);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Finalize, SB_PKCS11_Finalize, SB_PKCS11_Finalize);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetInfo, SB_PKCS11_GetInfo, SB_PKCS11_GetInfo);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetFunctionList, SB_PKCS11_GetFunctionList, SB_PKCS11_GetFunctionList);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetSlotList, SB_PKCS11_GetSlotList, SB_PKCS11_GetSlotList);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetSlotInfo, SB_PKCS11_GetSlotInfo, SB_PKCS11_GetSlotInfo);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetTokenInfo, SB_PKCS11_GetTokenInfo, SB_PKCS11_GetTokenInfo);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetMechanismList, SB_PKCS11_GetMechanismList, SB_PKCS11_GetMechanismList);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetMechanismInfo, SB_PKCS11_GetMechanismInfo, SB_PKCS11_GetMechanismInfo);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_InitToken, SB_PKCS11_InitToken, SB_PKCS11_InitToken);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_InitPIN, SB_PKCS11_InitPIN, SB_PKCS11_InitPIN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SetPIN, SB_PKCS11_SetPIN, SB_PKCS11_SetPIN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_OpenSession, SB_PKCS11_OpenSession, SB_PKCS11_OpenSession);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_CloseSession, SB_PKCS11_CloseSession, SB_PKCS11_CloseSession);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_CloseAllSessions, SB_PKCS11_CloseAllSessions, SB_PKCS11_CloseAllSessions);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetSessionInfo, SB_PKCS11_GetSessionInfo, SB_PKCS11_GetSessionInfo);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetOperationState, SB_PKCS11_GetOperationState, SB_PKCS11_GetOperationState);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SetOperationState, SB_PKCS11_SetOperationState, SB_PKCS11_SetOperationState);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Login, SB_PKCS11_Login, SB_PKCS11_Login);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Logout, SB_PKCS11_Logout, SB_PKCS11_Logout);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_CreateObject, SB_PKCS11_CreateObject, SB_PKCS11_CreateObject);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_CopyObject, SB_PKCS11_CopyObject, SB_PKCS11_CopyObject);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DestroyObject, SB_PKCS11_DestroyObject, SB_PKCS11_DestroyObject);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetObjectSize, SB_PKCS11_GetObjectSize, SB_PKCS11_GetObjectSize);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetAttributeValue, SB_PKCS11_GetAttributeValue, SB_PKCS11_GetAttributeValue);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SetAttributeValue, SB_PKCS11_SetAttributeValue, SB_PKCS11_SetAttributeValue);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_FindObjectsInit, SB_PKCS11_FindObjectsInit, SB_PKCS11_FindObjectsInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_FindObjects, SB_PKCS11_FindObjects, SB_PKCS11_FindObjects);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_FindObjectsFinal, SB_PKCS11_FindObjectsFinal, SB_PKCS11_FindObjectsFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_EncryptInit, SB_PKCS11_EncryptInit, SB_PKCS11_EncryptInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Encrypt, SB_PKCS11_Encrypt, SB_PKCS11_Encrypt);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_EncryptUpdate, SB_PKCS11_EncryptUpdate, SB_PKCS11_EncryptUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_EncryptFinal, SB_PKCS11_EncryptFinal, SB_PKCS11_EncryptFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DecryptInit, SB_PKCS11_DecryptInit, SB_PKCS11_DecryptInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Decrypt, SB_PKCS11_Decrypt, SB_PKCS11_Decrypt);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DecryptUpdate, SB_PKCS11_DecryptUpdate, SB_PKCS11_DecryptUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DecryptFinal, SB_PKCS11_DecryptFinal, SB_PKCS11_DecryptFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DigestInit, SB_PKCS11_DigestInit, SB_PKCS11_DigestInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Digest, SB_PKCS11_Digest, SB_PKCS11_Digest);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DigestUpdate, SB_PKCS11_DigestUpdate, SB_PKCS11_DigestUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DigestKey, SB_PKCS11_DigestKey, SB_PKCS11_DigestKey);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DigestFinal, SB_PKCS11_DigestFinal, SB_PKCS11_DigestFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignInit, SB_PKCS11_SignInit, SB_PKCS11_SignInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Sign, SB_PKCS11_Sign, SB_PKCS11_Sign);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignUpdate, SB_PKCS11_SignUpdate, SB_PKCS11_SignUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignFinal, SB_PKCS11_SignFinal, SB_PKCS11_SignFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignRecoverInit, SB_PKCS11_SignRecoverInit, SB_PKCS11_SignRecoverInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignRecover, SB_PKCS11_SignRecover, SB_PKCS11_SignRecover);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_VerifyInit, SB_PKCS11_VerifyInit, SB_PKCS11_VerifyInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_Verify, SB_PKCS11_Verify, SB_PKCS11_Verify);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_VerifyUpdate, SB_PKCS11_VerifyUpdate, SB_PKCS11_VerifyUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_VerifyFinal, SB_PKCS11_VerifyFinal, SB_PKCS11_VerifyFinal);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_VerifyRecoverInit, SB_PKCS11_VerifyRecoverInit, SB_PKCS11_VerifyRecoverInit);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_VerifyRecover, SB_PKCS11_VerifyRecover, SB_PKCS11_VerifyRecover);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DigestEncryptUpdate, SB_PKCS11_DigestEncryptUpdate, SB_PKCS11_DigestEncryptUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DecryptDigestUpdate, SB_PKCS11_DecryptDigestUpdate, SB_PKCS11_DecryptDigestUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SignEncryptUpdate, SB_PKCS11_SignEncryptUpdate, SB_PKCS11_SignEncryptUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DecryptVerifyUpdate, SB_PKCS11_DecryptVerifyUpdate, SB_PKCS11_DecryptVerifyUpdate);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GenerateKey, SB_PKCS11_GenerateKey, SB_PKCS11_GenerateKey);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GenerateKeyPair, SB_PKCS11_GenerateKeyPair, SB_PKCS11_GenerateKeyPair);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_WrapKey, SB_PKCS11_WrapKey, SB_PKCS11_WrapKey);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_UnwrapKey, SB_PKCS11_UnwrapKey, SB_PKCS11_UnwrapKey);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_DeriveKey, SB_PKCS11_DeriveKey, SB_PKCS11_DeriveKey);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_SeedRandom, SB_PKCS11_SeedRandom, SB_PKCS11_SeedRandom);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GenerateRandom, SB_PKCS11_GenerateRandom, SB_PKCS11_GenerateRandom);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_GetFunctionStatus, SB_PKCS11_GetFunctionStatus, SB_PKCS11_GetFunctionStatus);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_CancelFunction, SB_PKCS11_CancelFunction, SB_PKCS11_CancelFunction);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_WaitForSlotEvent, SB_PKCS11_WaitForSlotEvent, SB_PKCS11_WaitForSlotEvent);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, PKCS11_FUNC_LAST, SB_PKCS11_FUNC_LAST, SB_PKCS11_FUNC_LAST);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CK_TRUE, SB_CK_TRUE, SB_CK_TRUE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CK_FALSE, SB_CK_FALSE, SB_CK_FALSE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_OK, SB_CKR_OK, SB_CKR_OK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_CANCEL, SB_CKR_CANCEL, SB_CKR_CANCEL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_HOST_MEMORY, SB_CKR_HOST_MEMORY, SB_CKR_HOST_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SLOT_ID_INVALID, SB_CKR_SLOT_ID_INVALID, SB_CKR_SLOT_ID_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_GENERAL_ERROR, SB_CKR_GENERAL_ERROR, SB_CKR_GENERAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_FUNCTION_FAILED, SB_CKR_FUNCTION_FAILED, SB_CKR_FUNCTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ARGUMENTS_BAD, SB_CKR_ARGUMENTS_BAD, SB_CKR_ARGUMENTS_BAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_NO_EVENT, SB_CKR_NO_EVENT, SB_CKR_NO_EVENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_NEED_TO_CREATE_THREADS, SB_CKR_NEED_TO_CREATE_THREADS, SB_CKR_NEED_TO_CREATE_THREADS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_CANT_LOCK, SB_CKR_CANT_LOCK, SB_CKR_CANT_LOCK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ATTRIBUTE_READ_ONLY, SB_CKR_ATTRIBUTE_READ_ONLY, SB_CKR_ATTRIBUTE_READ_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ATTRIBUTE_SENSITIVE, SB_CKR_ATTRIBUTE_SENSITIVE, SB_CKR_ATTRIBUTE_SENSITIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ATTRIBUTE_TYPE_INVALID, SB_CKR_ATTRIBUTE_TYPE_INVALID, SB_CKR_ATTRIBUTE_TYPE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ATTRIBUTE_VALUE_INVALID, SB_CKR_ATTRIBUTE_VALUE_INVALID, SB_CKR_ATTRIBUTE_VALUE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_DATA_INVALID, SB_CKR_DATA_INVALID, SB_CKR_DATA_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_DATA_LEN_RANGE, SB_CKR_DATA_LEN_RANGE, SB_CKR_DATA_LEN_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_DEVICE_ERROR, SB_CKR_DEVICE_ERROR, SB_CKR_DEVICE_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_DEVICE_MEMORY, SB_CKR_DEVICE_MEMORY, SB_CKR_DEVICE_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_DEVICE_REMOVED, SB_CKR_DEVICE_REMOVED, SB_CKR_DEVICE_REMOVED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ENCRYPTED_DATA_INVALID, SB_CKR_ENCRYPTED_DATA_INVALID, SB_CKR_ENCRYPTED_DATA_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_ENCRYPTED_DATA_LEN_RANGE, SB_CKR_ENCRYPTED_DATA_LEN_RANGE, SB_CKR_ENCRYPTED_DATA_LEN_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_FUNCTION_CANCELED, SB_CKR_FUNCTION_CANCELED, SB_CKR_FUNCTION_CANCELED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_FUNCTION_NOT_PARALLEL, SB_CKR_FUNCTION_NOT_PARALLEL, SB_CKR_FUNCTION_NOT_PARALLEL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_FUNCTION_NOT_SUPPORTED, SB_CKR_FUNCTION_NOT_SUPPORTED, SB_CKR_FUNCTION_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_HANDLE_INVALID, SB_CKR_KEY_HANDLE_INVALID, SB_CKR_KEY_HANDLE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_SIZE_RANGE, SB_CKR_KEY_SIZE_RANGE, SB_CKR_KEY_SIZE_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_TYPE_INCONSISTENT, SB_CKR_KEY_TYPE_INCONSISTENT, SB_CKR_KEY_TYPE_INCONSISTENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_NOT_NEEDED, SB_CKR_KEY_NOT_NEEDED, SB_CKR_KEY_NOT_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_CHANGED, SB_CKR_KEY_CHANGED, SB_CKR_KEY_CHANGED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_NEEDED, SB_CKR_KEY_NEEDED, SB_CKR_KEY_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_INDIGESTIBLE, SB_CKR_KEY_INDIGESTIBLE, SB_CKR_KEY_INDIGESTIBLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_FUNCTION_NOT_PERMITTED, SB_CKR_KEY_FUNCTION_NOT_PERMITTED, SB_CKR_KEY_FUNCTION_NOT_PERMITTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_NOT_WRAPPABLE, SB_CKR_KEY_NOT_WRAPPABLE, SB_CKR_KEY_NOT_WRAPPABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_KEY_UNEXTRACTABLE, SB_CKR_KEY_UNEXTRACTABLE, SB_CKR_KEY_UNEXTRACTABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_MECHANISM_INVALID, SB_CKR_MECHANISM_INVALID, SB_CKR_MECHANISM_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_MECHANISM_PARAM_INVALID, SB_CKR_MECHANISM_PARAM_INVALID, SB_CKR_MECHANISM_PARAM_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_OBJECT_HANDLE_INVALID, SB_CKR_OBJECT_HANDLE_INVALID, SB_CKR_OBJECT_HANDLE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_OPERATION_ACTIVE, SB_CKR_OPERATION_ACTIVE, SB_CKR_OPERATION_ACTIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_OPERATION_NOT_INITIALIZED, SB_CKR_OPERATION_NOT_INITIALIZED, SB_CKR_OPERATION_NOT_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_PIN_INCORRECT, SB_CKR_PIN_INCORRECT, SB_CKR_PIN_INCORRECT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_PIN_INVALID, SB_CKR_PIN_INVALID, SB_CKR_PIN_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_PIN_LEN_RANGE, SB_CKR_PIN_LEN_RANGE, SB_CKR_PIN_LEN_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_PIN_EXPIRED, SB_CKR_PIN_EXPIRED, SB_CKR_PIN_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_PIN_LOCKED, SB_CKR_PIN_LOCKED, SB_CKR_PIN_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_CLOSED, SB_CKR_SESSION_CLOSED, SB_CKR_SESSION_CLOSED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_COUNT, SB_CKR_SESSION_COUNT, SB_CKR_SESSION_COUNT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_HANDLE_INVALID, SB_CKR_SESSION_HANDLE_INVALID, SB_CKR_SESSION_HANDLE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_PARALLEL_NOT_SUPPORTED, SB_CKR_SESSION_PARALLEL_NOT_SUPPORTED, SB_CKR_SESSION_PARALLEL_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_READ_ONLY, SB_CKR_SESSION_READ_ONLY, SB_CKR_SESSION_READ_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_EXISTS, SB_CKR_SESSION_EXISTS, SB_CKR_SESSION_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_READ_ONLY_EXISTS, SB_CKR_SESSION_READ_ONLY_EXISTS, SB_CKR_SESSION_READ_ONLY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SESSION_READ_WRITE_SO_EXISTS, SB_CKR_SESSION_READ_WRITE_SO_EXISTS, SB_CKR_SESSION_READ_WRITE_SO_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SIGNATURE_INVALID, SB_CKR_SIGNATURE_INVALID, SB_CKR_SIGNATURE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SIGNATURE_LEN_RANGE, SB_CKR_SIGNATURE_LEN_RANGE, SB_CKR_SIGNATURE_LEN_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_TEMPLATE_INCOMPLETE, SB_CKR_TEMPLATE_INCOMPLETE, SB_CKR_TEMPLATE_INCOMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_TEMPLATE_INCONSISTENT, SB_CKR_TEMPLATE_INCONSISTENT, SB_CKR_TEMPLATE_INCONSISTENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_TOKEN_NOT_PRESENT, SB_CKR_TOKEN_NOT_PRESENT, SB_CKR_TOKEN_NOT_PRESENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_TOKEN_NOT_RECOGNIZED, SB_CKR_TOKEN_NOT_RECOGNIZED, SB_CKR_TOKEN_NOT_RECOGNIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_TOKEN_WRITE_PROTECTED, SB_CKR_TOKEN_WRITE_PROTECTED, SB_CKR_TOKEN_WRITE_PROTECTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_UNWRAPPING_KEY_HANDLE_INVALID, SB_CKR_UNWRAPPING_KEY_HANDLE_INVALID, SB_CKR_UNWRAPPING_KEY_HANDLE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_UNWRAPPING_KEY_SIZE_RANGE, SB_CKR_UNWRAPPING_KEY_SIZE_RANGE, SB_CKR_UNWRAPPING_KEY_SIZE_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_UNWRAPPING_KEY_TYPE_INCONSISTENT, SB_CKR_UNWRAPPING_KEY_TYPE_INCONSISTENT, SB_CKR_UNWRAPPING_KEY_TYPE_INCONSISTENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_ALREADY_LOGGED_IN, SB_CKR_USER_ALREADY_LOGGED_IN, SB_CKR_USER_ALREADY_LOGGED_IN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_NOT_LOGGED_IN, SB_CKR_USER_NOT_LOGGED_IN, SB_CKR_USER_NOT_LOGGED_IN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_PIN_NOT_INITIALIZED, SB_CKR_USER_PIN_NOT_INITIALIZED, SB_CKR_USER_PIN_NOT_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_TYPE_INVALID, SB_CKR_USER_TYPE_INVALID, SB_CKR_USER_TYPE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_ANOTHER_ALREADY_LOGGED_IN, SB_CKR_USER_ANOTHER_ALREADY_LOGGED_IN, SB_CKR_USER_ANOTHER_ALREADY_LOGGED_IN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_USER_TOO_MANY_TYPES, SB_CKR_USER_TOO_MANY_TYPES, SB_CKR_USER_TOO_MANY_TYPES);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_WRAPPED_KEY_INVALID, SB_CKR_WRAPPED_KEY_INVALID, SB_CKR_WRAPPED_KEY_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_WRAPPED_KEY_LEN_RANGE, SB_CKR_WRAPPED_KEY_LEN_RANGE, SB_CKR_WRAPPED_KEY_LEN_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_WRAPPING_KEY_HANDLE_INVALID, SB_CKR_WRAPPING_KEY_HANDLE_INVALID, SB_CKR_WRAPPING_KEY_HANDLE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_WRAPPING_KEY_SIZE_RANGE, SB_CKR_WRAPPING_KEY_SIZE_RANGE, SB_CKR_WRAPPING_KEY_SIZE_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_WRAPPING_KEY_TYPE_INCONSISTENT, SB_CKR_WRAPPING_KEY_TYPE_INCONSISTENT, SB_CKR_WRAPPING_KEY_TYPE_INCONSISTENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_RANDOM_SEED_NOT_SUPPORTED, SB_CKR_RANDOM_SEED_NOT_SUPPORTED, SB_CKR_RANDOM_SEED_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_RANDOM_NO_RNG, SB_CKR_RANDOM_NO_RNG, SB_CKR_RANDOM_NO_RNG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_BUFFER_TOO_SMALL, SB_CKR_BUFFER_TOO_SMALL, SB_CKR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SAVED_STATE_INVALID, SB_CKR_SAVED_STATE_INVALID, SB_CKR_SAVED_STATE_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_INFORMATION_SENSITIVE, SB_CKR_INFORMATION_SENSITIVE, SB_CKR_INFORMATION_SENSITIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_STATE_UNSAVEABLE, SB_CKR_STATE_UNSAVEABLE, SB_CKR_STATE_UNSAVEABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_CRYPTOKI_NOT_INITIALIZED, SB_CKR_CRYPTOKI_NOT_INITIALIZED, SB_CKR_CRYPTOKI_NOT_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_CRYPTOKI_ALREADY_INITIALIZED, SB_CKR_CRYPTOKI_ALREADY_INITIALIZED, SB_CKR_CRYPTOKI_ALREADY_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_MUTEX_BAD, SB_CKR_MUTEX_BAD, SB_CKR_MUTEX_BAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_MUTEX_NOT_LOCKED, SB_CKR_MUTEX_NOT_LOCKED, SB_CKR_MUTEX_NOT_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_VENDOR_DEFINED, SB_CKR_VENDOR_DEFINED, SB_CKR_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKR_SBPKCS11PROXY_UNHANDLED_EXCEPTION, SB_CKR_SBPKCS11PROXY_UNHANDLED_EXCEPTION, SB_CKR_SBPKCS11PROXY_UNHANDLED_EXCEPTION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_PKCS11_VENDOR_DEFINED, SB_PKCS11_VENDOR_DEFINED, SB_PKCS11_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_TOKEN_PRESENT, SB_CKF_TOKEN_PRESENT, SB_CKF_TOKEN_PRESENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_REMOVABLE_DEVICE, SB_CKF_REMOVABLE_DEVICE, SB_CKF_REMOVABLE_DEVICE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_HW_SLOT, SB_CKF_HW_SLOT, SB_CKF_HW_SLOT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_DONT_BLOCK, SB_CKF_DONT_BLOCK, SB_CKF_DONT_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_RNG, SB_CKF_RNG, SB_CKF_RNG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_WRITE_PROTECTED, SB_CKF_WRITE_PROTECTED, SB_CKF_WRITE_PROTECTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_LOGIN_REQUIRED, SB_CKF_LOGIN_REQUIRED, SB_CKF_LOGIN_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_USER_PIN_INITIALIZED, SB_CKF_USER_PIN_INITIALIZED, SB_CKF_USER_PIN_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_RESTORE_KEY_NOT_NEEDED, SB_CKF_RESTORE_KEY_NOT_NEEDED, SB_CKF_RESTORE_KEY_NOT_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_CLOCK_ON_TOKEN, SB_CKF_CLOCK_ON_TOKEN, SB_CKF_CLOCK_ON_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_PROTECTED_AUTHENTICATION_PATH, SB_CKF_PROTECTED_AUTHENTICATION_PATH, SB_CKF_PROTECTED_AUTHENTICATION_PATH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_DUAL_CRYPTO_OPERATIONS, SB_CKF_DUAL_CRYPTO_OPERATIONS, SB_CKF_DUAL_CRYPTO_OPERATIONS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_TOKEN_INITIALIZED, SB_CKF_TOKEN_INITIALIZED, SB_CKF_TOKEN_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SECONDARY_AUTHENTICATION, SB_CKF_SECONDARY_AUTHENTICATION, SB_CKF_SECONDARY_AUTHENTICATION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_USER_PIN_COUNT_LOW, SB_CKF_USER_PIN_COUNT_LOW, SB_CKF_USER_PIN_COUNT_LOW);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_USER_PIN_FINAL_TRY, SB_CKF_USER_PIN_FINAL_TRY, SB_CKF_USER_PIN_FINAL_TRY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_USER_PIN_LOCKED, SB_CKF_USER_PIN_LOCKED, SB_CKF_USER_PIN_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_USER_PIN_TO_BE_CHANGED, SB_CKF_USER_PIN_TO_BE_CHANGED, SB_CKF_USER_PIN_TO_BE_CHANGED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SO_PIN_COUNT_LOW, SB_CKF_SO_PIN_COUNT_LOW, SB_CKF_SO_PIN_COUNT_LOW);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SO_PIN_FINAL_TRY, SB_CKF_SO_PIN_FINAL_TRY, SB_CKF_SO_PIN_FINAL_TRY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SO_PIN_LOCKED, SB_CKF_SO_PIN_LOCKED, SB_CKF_SO_PIN_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SO_PIN_TO_BE_CHANGED, SB_CKF_SO_PIN_TO_BE_CHANGED, SB_CKF_SO_PIN_TO_BE_CHANGED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_PKCS_KEY_PAIR_GEN, SB_CKM_RSA_PKCS_KEY_PAIR_GEN, SB_CKM_RSA_PKCS_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_PKCS, SB_CKM_RSA_PKCS, SB_CKM_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_9796, SB_CKM_RSA_9796, SB_CKM_RSA_9796);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_X_509, SB_CKM_RSA_X_509, SB_CKM_RSA_X_509);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD2_RSA_PKCS, SB_CKM_MD2_RSA_PKCS, SB_CKM_MD2_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD5_RSA_PKCS, SB_CKM_MD5_RSA_PKCS, SB_CKM_MD5_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA1_RSA_PKCS, SB_CKM_SHA1_RSA_PKCS, SB_CKM_SHA1_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD128_RSA_PKCS, SB_CKM_RIPEMD128_RSA_PKCS, SB_CKM_RIPEMD128_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD160_RSA_PKCS, SB_CKM_RIPEMD160_RSA_PKCS, SB_CKM_RIPEMD160_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_PKCS_OAEP, SB_CKM_RSA_PKCS_OAEP, SB_CKM_RSA_PKCS_OAEP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_X9_31_KEY_PAIR_GEN, SB_CKM_RSA_X9_31_KEY_PAIR_GEN, SB_CKM_RSA_X9_31_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_X9_31, SB_CKM_RSA_X9_31, SB_CKM_RSA_X9_31);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA1_RSA_X9_31, SB_CKM_SHA1_RSA_X9_31, SB_CKM_SHA1_RSA_X9_31);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RSA_PKCS_PSS, SB_CKM_RSA_PKCS_PSS, SB_CKM_RSA_PKCS_PSS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA1_RSA_PKCS_PSS, SB_CKM_SHA1_RSA_PKCS_PSS, SB_CKM_SHA1_RSA_PKCS_PSS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DSA_KEY_PAIR_GEN, SB_CKM_DSA_KEY_PAIR_GEN, SB_CKM_DSA_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DSA, SB_CKM_DSA, SB_CKM_DSA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DSA_SHA1, SB_CKM_DSA_SHA1, SB_CKM_DSA_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DH_PKCS_KEY_PAIR_GEN, SB_CKM_DH_PKCS_KEY_PAIR_GEN, SB_CKM_DH_PKCS_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DH_PKCS_DERIVE, SB_CKM_DH_PKCS_DERIVE, SB_CKM_DH_PKCS_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_X9_42_DH_KEY_PAIR_GEN, SB_CKM_X9_42_DH_KEY_PAIR_GEN, SB_CKM_X9_42_DH_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_X9_42_DH_DERIVE, SB_CKM_X9_42_DH_DERIVE, SB_CKM_X9_42_DH_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_X9_42_DH_HYBRID_DERIVE, SB_CKM_X9_42_DH_HYBRID_DERIVE, SB_CKM_X9_42_DH_HYBRID_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_X9_42_MQV_DERIVE, SB_CKM_X9_42_MQV_DERIVE, SB_CKM_X9_42_MQV_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA256_RSA_PKCS, SB_CKM_SHA256_RSA_PKCS, SB_CKM_SHA256_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA384_RSA_PKCS, SB_CKM_SHA384_RSA_PKCS, SB_CKM_SHA384_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA512_RSA_PKCS, SB_CKM_SHA512_RSA_PKCS, SB_CKM_SHA512_RSA_PKCS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA256_RSA_PKCS_PSS, SB_CKM_SHA256_RSA_PKCS_PSS, SB_CKM_SHA256_RSA_PKCS_PSS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA384_RSA_PKCS_PSS, SB_CKM_SHA384_RSA_PKCS_PSS, SB_CKM_SHA384_RSA_PKCS_PSS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA512_RSA_PKCS_PSS, SB_CKM_SHA512_RSA_PKCS_PSS, SB_CKM_SHA512_RSA_PKCS_PSS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_KEY_GEN, SB_CKM_RC2_KEY_GEN, SB_CKM_RC2_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_ECB, SB_CKM_RC2_ECB, SB_CKM_RC2_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_CBC, SB_CKM_RC2_CBC, SB_CKM_RC2_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_MAC, SB_CKM_RC2_MAC, SB_CKM_RC2_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_MAC_GENERAL, SB_CKM_RC2_MAC_GENERAL, SB_CKM_RC2_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC2_CBC_PAD, SB_CKM_RC2_CBC_PAD, SB_CKM_RC2_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC4_KEY_GEN, SB_CKM_RC4_KEY_GEN, SB_CKM_RC4_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC4, SB_CKM_RC4, SB_CKM_RC4);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_KEY_GEN, SB_CKM_DES_KEY_GEN, SB_CKM_DES_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_ECB, SB_CKM_DES_ECB, SB_CKM_DES_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_CBC, SB_CKM_DES_CBC, SB_CKM_DES_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_MAC, SB_CKM_DES_MAC, SB_CKM_DES_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_MAC_GENERAL, SB_CKM_DES_MAC_GENERAL, SB_CKM_DES_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES_CBC_PAD, SB_CKM_DES_CBC_PAD, SB_CKM_DES_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES2_KEY_GEN, SB_CKM_DES2_KEY_GEN, SB_CKM_DES2_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_KEY_GEN, SB_CKM_DES3_KEY_GEN, SB_CKM_DES3_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_ECB, SB_CKM_DES3_ECB, SB_CKM_DES3_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_CBC, SB_CKM_DES3_CBC, SB_CKM_DES3_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_MAC, SB_CKM_DES3_MAC, SB_CKM_DES3_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_MAC_GENERAL, SB_CKM_DES3_MAC_GENERAL, SB_CKM_DES3_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DES3_CBC_PAD, SB_CKM_DES3_CBC_PAD, SB_CKM_DES3_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_KEY_GEN, SB_CKM_CDMF_KEY_GEN, SB_CKM_CDMF_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_ECB, SB_CKM_CDMF_ECB, SB_CKM_CDMF_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_CBC, SB_CKM_CDMF_CBC, SB_CKM_CDMF_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_MAC, SB_CKM_CDMF_MAC, SB_CKM_CDMF_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_MAC_GENERAL, SB_CKM_CDMF_MAC_GENERAL, SB_CKM_CDMF_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CDMF_CBC_PAD, SB_CKM_CDMF_CBC_PAD, SB_CKM_CDMF_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD2, SB_CKM_MD2, SB_CKM_MD2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD2_HMAC, SB_CKM_MD2_HMAC, SB_CKM_MD2_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD2_HMAC_GENERAL, SB_CKM_MD2_HMAC_GENERAL, SB_CKM_MD2_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD5, SB_CKM_MD5, SB_CKM_MD5);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD5_HMAC, SB_CKM_MD5_HMAC, SB_CKM_MD5_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD5_HMAC_GENERAL, SB_CKM_MD5_HMAC_GENERAL, SB_CKM_MD5_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA_1, SB_CKM_SHA_1, SB_CKM_SHA_1);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA_1_HMAC, SB_CKM_SHA_1_HMAC, SB_CKM_SHA_1_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA_1_HMAC_GENERAL, SB_CKM_SHA_1_HMAC_GENERAL, SB_CKM_SHA_1_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD128, SB_CKM_RIPEMD128, SB_CKM_RIPEMD128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD128_HMAC, SB_CKM_RIPEMD128_HMAC, SB_CKM_RIPEMD128_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD128_HMAC_GENERAL, SB_CKM_RIPEMD128_HMAC_GENERAL, SB_CKM_RIPEMD128_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD160, SB_CKM_RIPEMD160, SB_CKM_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD160_HMAC, SB_CKM_RIPEMD160_HMAC, SB_CKM_RIPEMD160_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RIPEMD160_HMAC_GENERAL, SB_CKM_RIPEMD160_HMAC_GENERAL, SB_CKM_RIPEMD160_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_KEY_GEN, SB_CKM_CAST_KEY_GEN, SB_CKM_CAST_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_ECB, SB_CKM_CAST_ECB, SB_CKM_CAST_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_CBC, SB_CKM_CAST_CBC, SB_CKM_CAST_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_MAC, SB_CKM_CAST_MAC, SB_CKM_CAST_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_MAC_GENERAL, SB_CKM_CAST_MAC_GENERAL, SB_CKM_CAST_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST_CBC_PAD, SB_CKM_CAST_CBC_PAD, SB_CKM_CAST_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_KEY_GEN, SB_CKM_CAST3_KEY_GEN, SB_CKM_CAST3_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_ECB, SB_CKM_CAST3_ECB, SB_CKM_CAST3_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_CBC, SB_CKM_CAST3_CBC, SB_CKM_CAST3_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_MAC, SB_CKM_CAST3_MAC, SB_CKM_CAST3_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_MAC_GENERAL, SB_CKM_CAST3_MAC_GENERAL, SB_CKM_CAST3_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST3_CBC_PAD, SB_CKM_CAST3_CBC_PAD, SB_CKM_CAST3_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_KEY_GEN, SB_CKM_CAST5_KEY_GEN, SB_CKM_CAST5_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_KEY_GEN, SB_CKM_CAST128_KEY_GEN, SB_CKM_CAST128_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_ECB, SB_CKM_CAST5_ECB, SB_CKM_CAST5_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_ECB, SB_CKM_CAST128_ECB, SB_CKM_CAST128_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_CBC, SB_CKM_CAST5_CBC, SB_CKM_CAST5_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_CBC, SB_CKM_CAST128_CBC, SB_CKM_CAST128_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_MAC, SB_CKM_CAST5_MAC, SB_CKM_CAST5_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_MAC, SB_CKM_CAST128_MAC, SB_CKM_CAST128_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_MAC_GENERAL, SB_CKM_CAST5_MAC_GENERAL, SB_CKM_CAST5_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_MAC_GENERAL, SB_CKM_CAST128_MAC_GENERAL, SB_CKM_CAST128_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST5_CBC_PAD, SB_CKM_CAST5_CBC_PAD, SB_CKM_CAST5_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CAST128_CBC_PAD, SB_CKM_CAST128_CBC_PAD, SB_CKM_CAST128_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_KEY_GEN, SB_CKM_RC5_KEY_GEN, SB_CKM_RC5_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_ECB, SB_CKM_RC5_ECB, SB_CKM_RC5_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_CBC, SB_CKM_RC5_CBC, SB_CKM_RC5_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_MAC, SB_CKM_RC5_MAC, SB_CKM_RC5_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_MAC_GENERAL, SB_CKM_RC5_MAC_GENERAL, SB_CKM_RC5_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_RC5_CBC_PAD, SB_CKM_RC5_CBC_PAD, SB_CKM_RC5_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_KEY_GEN, SB_CKM_IDEA_KEY_GEN, SB_CKM_IDEA_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_ECB, SB_CKM_IDEA_ECB, SB_CKM_IDEA_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_CBC, SB_CKM_IDEA_CBC, SB_CKM_IDEA_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_MAC, SB_CKM_IDEA_MAC, SB_CKM_IDEA_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_MAC_GENERAL, SB_CKM_IDEA_MAC_GENERAL, SB_CKM_IDEA_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_IDEA_CBC_PAD, SB_CKM_IDEA_CBC_PAD, SB_CKM_IDEA_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_GENERIC_SECRET_KEY_GEN, SB_CKM_GENERIC_SECRET_KEY_GEN, SB_CKM_GENERIC_SECRET_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CONCATENATE_BASE_AND_KEY, SB_CKM_CONCATENATE_BASE_AND_KEY, SB_CKM_CONCATENATE_BASE_AND_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CONCATENATE_BASE_AND_DATA, SB_CKM_CONCATENATE_BASE_AND_DATA, SB_CKM_CONCATENATE_BASE_AND_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CONCATENATE_DATA_AND_BASE, SB_CKM_CONCATENATE_DATA_AND_BASE, SB_CKM_CONCATENATE_DATA_AND_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_XOR_BASE_AND_DATA, SB_CKM_XOR_BASE_AND_DATA, SB_CKM_XOR_BASE_AND_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_EXTRACT_KEY_FROM_KEY, SB_CKM_EXTRACT_KEY_FROM_KEY, SB_CKM_EXTRACT_KEY_FROM_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_PRE_MASTER_KEY_GEN, SB_CKM_SSL3_PRE_MASTER_KEY_GEN, SB_CKM_SSL3_PRE_MASTER_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_MASTER_KEY_DERIVE, SB_CKM_SSL3_MASTER_KEY_DERIVE, SB_CKM_SSL3_MASTER_KEY_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_KEY_AND_MAC_DERIVE, SB_CKM_SSL3_KEY_AND_MAC_DERIVE, SB_CKM_SSL3_KEY_AND_MAC_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_MASTER_KEY_DERIVE_DH, SB_CKM_SSL3_MASTER_KEY_DERIVE_DH, SB_CKM_SSL3_MASTER_KEY_DERIVE_DH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_TLS_PRE_MASTER_KEY_GEN, SB_CKM_TLS_PRE_MASTER_KEY_GEN, SB_CKM_TLS_PRE_MASTER_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_TLS_MASTER_KEY_DERIVE, SB_CKM_TLS_MASTER_KEY_DERIVE, SB_CKM_TLS_MASTER_KEY_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_TLS_KEY_AND_MAC_DERIVE, SB_CKM_TLS_KEY_AND_MAC_DERIVE, SB_CKM_TLS_KEY_AND_MAC_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_TLS_MASTER_KEY_DERIVE_DH, SB_CKM_TLS_MASTER_KEY_DERIVE_DH, SB_CKM_TLS_MASTER_KEY_DERIVE_DH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_MD5_MAC, SB_CKM_SSL3_MD5_MAC, SB_CKM_SSL3_MD5_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SSL3_SHA1_MAC, SB_CKM_SSL3_SHA1_MAC, SB_CKM_SSL3_SHA1_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD5_KEY_DERIVATION, SB_CKM_MD5_KEY_DERIVATION, SB_CKM_MD5_KEY_DERIVATION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_MD2_KEY_DERIVATION, SB_CKM_MD2_KEY_DERIVATION, SB_CKM_MD2_KEY_DERIVATION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA1_KEY_DERIVATION, SB_CKM_SHA1_KEY_DERIVATION, SB_CKM_SHA1_KEY_DERIVATION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD2_DES_CBC, SB_CKM_PBE_MD2_DES_CBC, SB_CKM_PBE_MD2_DES_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD5_DES_CBC, SB_CKM_PBE_MD5_DES_CBC, SB_CKM_PBE_MD5_DES_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD5_CAST_CBC, SB_CKM_PBE_MD5_CAST_CBC, SB_CKM_PBE_MD5_CAST_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD5_CAST3_CBC, SB_CKM_PBE_MD5_CAST3_CBC, SB_CKM_PBE_MD5_CAST3_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD5_CAST5_CBC, SB_CKM_PBE_MD5_CAST5_CBC, SB_CKM_PBE_MD5_CAST5_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_MD5_CAST128_CBC, SB_CKM_PBE_MD5_CAST128_CBC, SB_CKM_PBE_MD5_CAST128_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_CAST5_CBC, SB_CKM_PBE_SHA1_CAST5_CBC, SB_CKM_PBE_SHA1_CAST5_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_CAST128_CBC, SB_CKM_PBE_SHA1_CAST128_CBC, SB_CKM_PBE_SHA1_CAST128_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_RC4_128, SB_CKM_PBE_SHA1_RC4_128, SB_CKM_PBE_SHA1_RC4_128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_RC4_40, SB_CKM_PBE_SHA1_RC4_40, SB_CKM_PBE_SHA1_RC4_40);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_DES3_EDE_CBC, SB_CKM_PBE_SHA1_DES3_EDE_CBC, SB_CKM_PBE_SHA1_DES3_EDE_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_DES2_EDE_CBC, SB_CKM_PBE_SHA1_DES2_EDE_CBC, SB_CKM_PBE_SHA1_DES2_EDE_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_RC2_128_CBC, SB_CKM_PBE_SHA1_RC2_128_CBC, SB_CKM_PBE_SHA1_RC2_128_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBE_SHA1_RC2_40_CBC, SB_CKM_PBE_SHA1_RC2_40_CBC, SB_CKM_PBE_SHA1_RC2_40_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PKCS5_PBKD2, SB_CKM_PKCS5_PBKD2, SB_CKM_PKCS5_PBKD2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_PBA_SHA1_WITH_SHA1_HMAC, SB_CKM_PBA_SHA1_WITH_SHA1_HMAC, SB_CKM_PBA_SHA1_WITH_SHA1_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_KEY_WRAP_LYNKS, SB_CKM_KEY_WRAP_LYNKS, SB_CKM_KEY_WRAP_LYNKS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_KEY_WRAP_SET_OAEP, SB_CKM_KEY_WRAP_SET_OAEP, SB_CKM_KEY_WRAP_SET_OAEP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_CMS_SIG, SB_CKM_CMS_SIG, SB_CKM_CMS_SIG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_KEY_GEN, SB_CKM_SKIPJACK_KEY_GEN, SB_CKM_SKIPJACK_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_ECB64, SB_CKM_SKIPJACK_ECB64, SB_CKM_SKIPJACK_ECB64);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_CBC64, SB_CKM_SKIPJACK_CBC64, SB_CKM_SKIPJACK_CBC64);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_OFB64, SB_CKM_SKIPJACK_OFB64, SB_CKM_SKIPJACK_OFB64);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_CFB64, SB_CKM_SKIPJACK_CFB64, SB_CKM_SKIPJACK_CFB64);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_CFB32, SB_CKM_SKIPJACK_CFB32, SB_CKM_SKIPJACK_CFB32);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_CFB16, SB_CKM_SKIPJACK_CFB16, SB_CKM_SKIPJACK_CFB16);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_CFB8, SB_CKM_SKIPJACK_CFB8, SB_CKM_SKIPJACK_CFB8);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_WRAP, SB_CKM_SKIPJACK_WRAP, SB_CKM_SKIPJACK_WRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_PRIVATE_WRAP, SB_CKM_SKIPJACK_PRIVATE_WRAP, SB_CKM_SKIPJACK_PRIVATE_WRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SKIPJACK_RELAYX, SB_CKM_SKIPJACK_RELAYX, SB_CKM_SKIPJACK_RELAYX);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_KEA_KEY_PAIR_GEN, SB_CKM_KEA_KEY_PAIR_GEN, SB_CKM_KEA_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_KEA_KEY_DERIVE, SB_CKM_KEA_KEY_DERIVE, SB_CKM_KEA_KEY_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_FORTEZZA_TIMESTAMP, SB_CKM_FORTEZZA_TIMESTAMP, SB_CKM_FORTEZZA_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_KEY_GEN, SB_CKM_BATON_KEY_GEN, SB_CKM_BATON_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_ECB128, SB_CKM_BATON_ECB128, SB_CKM_BATON_ECB128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_ECB96, SB_CKM_BATON_ECB96, SB_CKM_BATON_ECB96);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_CBC128, SB_CKM_BATON_CBC128, SB_CKM_BATON_CBC128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_COUNTER, SB_CKM_BATON_COUNTER, SB_CKM_BATON_COUNTER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_SHUFFLE, SB_CKM_BATON_SHUFFLE, SB_CKM_BATON_SHUFFLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_BATON_WRAP, SB_CKM_BATON_WRAP, SB_CKM_BATON_WRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECDSA_KEY_PAIR_GEN, SB_CKM_ECDSA_KEY_PAIR_GEN, SB_CKM_ECDSA_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_EC_KEY_PAIR_GEN, SB_CKM_EC_KEY_PAIR_GEN, SB_CKM_EC_KEY_PAIR_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECDSA, SB_CKM_ECDSA, SB_CKM_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECDSA_SHA1, SB_CKM_ECDSA_SHA1, SB_CKM_ECDSA_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECDH1_DERIVE, SB_CKM_ECDH1_DERIVE, SB_CKM_ECDH1_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECDH1_COFACTOR_DERIVE, SB_CKM_ECDH1_COFACTOR_DERIVE, SB_CKM_ECDH1_COFACTOR_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_ECMQV_DERIVE, SB_CKM_ECMQV_DERIVE, SB_CKM_ECMQV_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_KEY_GEN, SB_CKM_JUNIPER_KEY_GEN, SB_CKM_JUNIPER_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_ECB128, SB_CKM_JUNIPER_ECB128, SB_CKM_JUNIPER_ECB128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_CBC128, SB_CKM_JUNIPER_CBC128, SB_CKM_JUNIPER_CBC128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_COUNTER, SB_CKM_JUNIPER_COUNTER, SB_CKM_JUNIPER_COUNTER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_SHUFFLE, SB_CKM_JUNIPER_SHUFFLE, SB_CKM_JUNIPER_SHUFFLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_JUNIPER_WRAP, SB_CKM_JUNIPER_WRAP, SB_CKM_JUNIPER_WRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_FASTHASH, SB_CKM_FASTHASH, SB_CKM_FASTHASH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_KEY_GEN, SB_CKM_AES_KEY_GEN, SB_CKM_AES_KEY_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_ECB, SB_CKM_AES_ECB, SB_CKM_AES_ECB);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_CBC, SB_CKM_AES_CBC, SB_CKM_AES_CBC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_MAC, SB_CKM_AES_MAC, SB_CKM_AES_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_MAC_GENERAL, SB_CKM_AES_MAC_GENERAL, SB_CKM_AES_MAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_AES_CBC_PAD, SB_CKM_AES_CBC_PAD, SB_CKM_AES_CBC_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DSA_PARAMETER_GEN, SB_CKM_DSA_PARAMETER_GEN, SB_CKM_DSA_PARAMETER_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_DH_PKCS_PARAMETER_GEN, SB_CKM_DH_PKCS_PARAMETER_GEN, SB_CKM_DH_PKCS_PARAMETER_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_X9_42_DH_PARAMETER_GEN, SB_CKM_X9_42_DH_PARAMETER_GEN, SB_CKM_X9_42_DH_PARAMETER_GEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA256, SB_CKM_SHA256, SB_CKM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA256_HMAC, SB_CKM_SHA256_HMAC, SB_CKM_SHA256_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA256_HMAC_GENERAL, SB_CKM_SHA256_HMAC_GENERAL, SB_CKM_SHA256_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA384, SB_CKM_SHA384, SB_CKM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA384_HMAC, SB_CKM_SHA384_HMAC, SB_CKM_SHA384_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA384_HMAC_GENERAL, SB_CKM_SHA384_HMAC_GENERAL, SB_CKM_SHA384_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA512, SB_CKM_SHA512, SB_CKM_SHA512);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA512_HMAC, SB_CKM_SHA512_HMAC, SB_CKM_SHA512_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_SHA512_HMAC_GENERAL, SB_CKM_SHA512_HMAC_GENERAL, SB_CKM_SHA512_HMAC_GENERAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKM_VENDOR_DEFINED, SB_CKM_VENDOR_DEFINED, SB_CKM_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CK_B_FALSE, SB_CK_B_FALSE, SB_CK_B_FALSE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CK_B_TRUE, SB_CK_B_TRUE, SB_CK_B_TRUE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CK_INVALID_HANDLE, SB_CK_INVALID_HANDLE, SB_CK_INVALID_HANDLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_CLASS, SB_CKA_CLASS, SB_CKA_CLASS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_TOKEN, SB_CKA_TOKEN, SB_CKA_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIVATE, SB_CKA_PRIVATE, SB_CKA_PRIVATE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_MODIFIABLE, SB_CKA_MODIFIABLE, SB_CKA_MODIFIABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_LABEL, SB_CKA_LABEL, SB_CKA_LABEL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_APPLICATION, SB_CKA_APPLICATION, SB_CKA_APPLICATION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_VALUE, SB_CKA_VALUE, SB_CKA_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_OBJECT_ID, SB_CKA_OBJECT_ID, SB_CKA_OBJECT_ID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_CERTIFICATE_TYPE, SB_CKA_CERTIFICATE_TYPE, SB_CKA_CERTIFICATE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ISSUER, SB_CKA_ISSUER, SB_CKA_ISSUER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SERIAL_NUMBER, SB_CKA_SERIAL_NUMBER, SB_CKA_SERIAL_NUMBER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_AC_ISSUER, SB_CKA_AC_ISSUER, SB_CKA_AC_ISSUER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_OWNER, SB_CKA_OWNER, SB_CKA_OWNER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ATTR_TYPES, SB_CKA_ATTR_TYPES, SB_CKA_ATTR_TYPES);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_VALUE_LEN, SB_CKA_VALUE_LEN, SB_CKA_VALUE_LEN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_TRUSTED, SB_CKA_TRUSTED, SB_CKA_TRUSTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_CERTIFICATE_CATEGORY, SB_CKA_CERTIFICATE_CATEGORY, SB_CKA_CERTIFICATE_CATEGORY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_URL, SB_CKA_URL, SB_CKA_URL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_KEY_TYPE, SB_CKA_KEY_TYPE, SB_CKA_KEY_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SUBJECT, SB_CKA_SUBJECT, SB_CKA_SUBJECT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ID, SB_CKA_ID, SB_CKA_ID);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SENSITIVE, SB_CKA_SENSITIVE, SB_CKA_SENSITIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ENCRYPT, SB_CKA_ENCRYPT, SB_CKA_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_DECRYPT, SB_CKA_DECRYPT, SB_CKA_DECRYPT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_WRAP, SB_CKA_WRAP, SB_CKA_WRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_UNWRAP, SB_CKA_UNWRAP, SB_CKA_UNWRAP);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SIGN, SB_CKA_SIGN, SB_CKA_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SIGN_RECOVER, SB_CKA_SIGN_RECOVER, SB_CKA_SIGN_RECOVER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_VERIFY, SB_CKA_VERIFY, SB_CKA_VERIFY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_VERIFY_RECOVER, SB_CKA_VERIFY_RECOVER, SB_CKA_VERIFY_RECOVER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_DERIVE, SB_CKA_DERIVE, SB_CKA_DERIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_START_DATE, SB_CKA_START_DATE, SB_CKA_START_DATE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_END_DATE, SB_CKA_END_DATE, SB_CKA_END_DATE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_LOCAL, SB_CKA_LOCAL, SB_CKA_LOCAL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_MODULUS, SB_CKA_MODULUS, SB_CKA_MODULUS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_MODULUS_BITS, SB_CKA_MODULUS_BITS, SB_CKA_MODULUS_BITS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PUBLIC_EXPONENT, SB_CKA_PUBLIC_EXPONENT, SB_CKA_PUBLIC_EXPONENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIVATE_EXPONENT, SB_CKA_PRIVATE_EXPONENT, SB_CKA_PRIVATE_EXPONENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIME_1, SB_CKA_PRIME_1, SB_CKA_PRIME_1);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIME_2, SB_CKA_PRIME_2, SB_CKA_PRIME_2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_EXPONENT_1, SB_CKA_EXPONENT_1, SB_CKA_EXPONENT_1);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_EXPONENT_2, SB_CKA_EXPONENT_2, SB_CKA_EXPONENT_2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_COEFFICIENT, SB_CKA_COEFFICIENT, SB_CKA_COEFFICIENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIME, SB_CKA_PRIME, SB_CKA_PRIME);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SUBPRIME, SB_CKA_SUBPRIME, SB_CKA_SUBPRIME);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_BASE, SB_CKA_BASE, SB_CKA_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_EXTRACTABLE, SB_CKA_EXTRACTABLE, SB_CKA_EXTRACTABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_NEVER_EXTRACTABLE, SB_CKA_NEVER_EXTRACTABLE, SB_CKA_NEVER_EXTRACTABLE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ALWAYS_SENSITIVE, SB_CKA_ALWAYS_SENSITIVE, SB_CKA_ALWAYS_SENSITIVE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_WRAP_WITH_TRUSTED, SB_CKA_WRAP_WITH_TRUSTED, SB_CKA_WRAP_WITH_TRUSTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_CHECK_VALUE, SB_CKA_CHECK_VALUE, SB_CKA_CHECK_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_PRIME_BITS, SB_CKA_PRIME_BITS, SB_CKA_PRIME_BITS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_SUBPRIME_BITS, SB_CKA_SUBPRIME_BITS, SB_CKA_SUBPRIME_BITS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ALWAYS_AUTHENTICATE, SB_CKA_ALWAYS_AUTHENTICATE, SB_CKA_ALWAYS_AUTHENTICATE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_HASH_OF_SUBJECT_PUBLIC_KEY, SB_CKA_HASH_OF_SUBJECT_PUBLIC_KEY, SB_CKA_HASH_OF_SUBJECT_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_HASH_OF_ISSUER_PUBLIC_KEY, SB_CKA_HASH_OF_ISSUER_PUBLIC_KEY, SB_CKA_HASH_OF_ISSUER_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_JAVA_MIDP_SECURITY_DOMAIN, SB_CKA_JAVA_MIDP_SECURITY_DOMAIN, SB_CKA_JAVA_MIDP_SECURITY_DOMAIN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_ECDSA_PARAMS, SB_CKA_ECDSA_PARAMS, SB_CKA_ECDSA_PARAMS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_EC_PARAMS, SB_CKA_EC_PARAMS, SB_CKA_EC_PARAMS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_EC_POINT, SB_CKA_EC_POINT, SB_CKA_EC_POINT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKA_UNDEFINED, SB_CKA_UNDEFINED, SB_CKA_UNDEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKC_X_509, SB_CKC_X_509, SB_CKC_X_509);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKC_X_509_ATTR_CERT, SB_CKC_X_509_ATTR_CERT, SB_CKC_X_509_ATTR_CERT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKC_WTLS, SB_CKC_WTLS, SB_CKC_WTLS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKC_VENDOR_DEFINED, SB_CKC_VENDOR_DEFINED, SB_CKC_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_OS_LOCKING_OK, SB_CKF_OS_LOCKING_OK, SB_CKF_OS_LOCKING_OK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_RW_SESSION, SB_CKF_RW_SESSION, SB_CKF_RW_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKF_SERIAL_SESSION, SB_CKF_SERIAL_SESSION, SB_CKF_SERIAL_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_RSA, SB_CKK_RSA, SB_CKK_RSA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_DSA, SB_CKK_DSA, SB_CKK_DSA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_DH, SB_CKK_DH, SB_CKK_DH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_ECDSA, SB_CKK_ECDSA, SB_CKK_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_EC, SB_CKK_EC, SB_CKK_EC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_X9_42_DH, SB_CKK_X9_42_DH, SB_CKK_X9_42_DH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_KEA, SB_CKK_KEA, SB_CKK_KEA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_GENERIC_SECRET, SB_CKK_GENERIC_SECRET, SB_CKK_GENERIC_SECRET);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_RC2, SB_CKK_RC2, SB_CKK_RC2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_RC4, SB_CKK_RC4, SB_CKK_RC4);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_DES, SB_CKK_DES, SB_CKK_DES);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_DES2, SB_CKK_DES2, SB_CKK_DES2);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_DES3, SB_CKK_DES3, SB_CKK_DES3);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_CAST, SB_CKK_CAST, SB_CKK_CAST);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_CAST3, SB_CKK_CAST3, SB_CKK_CAST3);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_CAST5, SB_CKK_CAST5, SB_CKK_CAST5);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_CAST128, SB_CKK_CAST128, SB_CKK_CAST128);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_RC5, SB_CKK_RC5, SB_CKK_RC5);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_IDEA, SB_CKK_IDEA, SB_CKK_IDEA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_SKIPJACK, SB_CKK_SKIPJACK, SB_CKK_SKIPJACK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_BATON, SB_CKK_BATON, SB_CKK_BATON);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_JUNIPER, SB_CKK_JUNIPER, SB_CKK_JUNIPER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_CDMF, SB_CKK_CDMF, SB_CKK_CDMF);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_AES, SB_CKK_AES, SB_CKK_AES);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_BLOWFISH, SB_CKK_BLOWFISH, SB_CKK_BLOWFISH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_TWOFISH, SB_CKK_TWOFISH, SB_CKK_TWOFISH);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKK_VENDOR_DEFINED, SB_CKK_VENDOR_DEFINED, SB_CKK_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKN_SURRENDER, SB_CKN_SURRENDER, SB_CKN_SURRENDER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_DATA, SB_CKO_DATA, SB_CKO_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_CERTIFICATE, SB_CKO_CERTIFICATE, SB_CKO_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_PUBLIC_KEY, SB_CKO_PUBLIC_KEY, SB_CKO_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_PRIVATE_KEY, SB_CKO_PRIVATE_KEY, SB_CKO_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_SECRET_KEY, SB_CKO_SECRET_KEY, SB_CKO_SECRET_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_HW_FEATURE, SB_CKO_HW_FEATURE, SB_CKO_HW_FEATURE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_DOMAIN_PARAMETERS, SB_CKO_DOMAIN_PARAMETERS, SB_CKO_DOMAIN_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_MECHANISM, SB_CKO_MECHANISM, SB_CKO_MECHANISM);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_VENDOR_DEFINED, SB_CKO_VENDOR_DEFINED, SB_CKO_VENDOR_DEFINED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKO_UNKNOWN, SB_CKO_UNKNOWN, SB_CKO_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKS_RO_PUBLIC_SESSION, SB_CKS_RO_PUBLIC_SESSION, SB_CKS_RO_PUBLIC_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKS_RO_USER_FUNCTIONS, SB_CKS_RO_USER_FUNCTIONS, SB_CKS_RO_USER_FUNCTIONS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKS_RW_PUBLIC_SESSION, SB_CKS_RW_PUBLIC_SESSION, SB_CKS_RW_PUBLIC_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKS_RW_USER_FUNCTIONS, SB_CKS_RW_USER_FUNCTIONS, SB_CKS_RW_USER_FUNCTIONS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKS_RW_SO_FUNCTIONS, SB_CKS_RW_SO_FUNCTIONS, SB_CKS_RW_SO_FUNCTIONS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKU_SO, SB_CKU_SO, SB_CKU_SO);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKU_USER, SB_CKU_USER, SB_CKU_USER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Common, SB_CKU_CONTEXT_SPECIFIC, SB_CKU_CONTEXT_SPECIFIC, SB_CKU_CONTEXT_SPECIFIC);
	SB_REGISTER_NULL_CONSTANT(SBPKCS11Common, SB_NULL_PTR, SB_NULL_PTR);
}

void Register_SBPKCS11Common_Aliases(TSRMLS_D)
{
	if (NULL == TPKCS11FunctionList_ce_ptr)
		Register_TPKCS11FunctionList(TSRMLS_C);
	zend_register_class_alias("SB_CK_FUNCTION_LIST", TPKCS11FunctionList_ce_ptr);
	if (NULL == TPKCS11InitializeArgs_ce_ptr)
		Register_TPKCS11InitializeArgs(TSRMLS_C);
	zend_register_class_alias("SB_CK_C_INITIALIZE_ARGS", TPKCS11InitializeArgs_ce_ptr);
	if (NULL == TPKCS11InitializeArgsNSS_ce_ptr)
		Register_TPKCS11InitializeArgsNSS(TSRMLS_C);
	zend_register_class_alias("SB_CK_C_INITIALIZE_ARGS_NSS", TPKCS11InitializeArgsNSS_ce_ptr);
	if (NULL == TPKCS11Info_ce_ptr)
		Register_TPKCS11Info(TSRMLS_C);
	zend_register_class_alias("SB_CK_INFO", TPKCS11Info_ce_ptr);
	if (NULL == TPKCS11SlotInfo_ce_ptr)
		Register_TPKCS11SlotInfo(TSRMLS_C);
	zend_register_class_alias("SB_CK_SLOT_INFO", TPKCS11SlotInfo_ce_ptr);
	if (NULL == TPKCS11TokenInfo_ce_ptr)
		Register_TPKCS11TokenInfo(TSRMLS_C);
	zend_register_class_alias("SB_CK_TOKEN_INFO", TPKCS11TokenInfo_ce_ptr);
	if (NULL == TPKCS11SessionInfo_ce_ptr)
		Register_TPKCS11SessionInfo(TSRMLS_C);
	zend_register_class_alias("SB_CK_SESSION_INFO", TPKCS11SessionInfo_ce_ptr);
	if (NULL == TPKCS11Attribute_ce_ptr)
		Register_TPKCS11Attribute(TSRMLS_C);
	zend_register_class_alias("SB_CK_ATTRIBUTE", TPKCS11Attribute_ce_ptr);
	if (NULL == TPKCS11MechanismInfo_ce_ptr)
		Register_TPKCS11MechanismInfo(TSRMLS_C);
	zend_register_class_alias("SB_CK_MECHANISM_INFO", TPKCS11MechanismInfo_ce_ptr);
}
