#ifndef __INC_CSKS_X_1001
#define __INC_CSKS_X_1001

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlKS_X_1001Handle;

#ifdef SB_USE_CLASS_TPLKS_X_1001
SB_IMPORT uint32_t SB_APIENTRY TPlKS_X_1001_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlKS_X_1001_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlKS_X_1001_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLKS_X_1001 */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlKS_X_1001_ce_ptr;

void Register_TPlKS_X_1001(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSKS_X_1001 */

