#include "sbaes.h"

SB_PHP_METHOD(TAESBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESBuffer));
		intern->len = sizeof(TAESBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESBuffer));
}

zend_class_entry *TAESBuffer_ce_ptr = NULL;

static zend_function_entry TAESBuffer_methods[] = {
	PHP_ME(TAESBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESBuffer", TAESBuffer_methods);
	TAESBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESKey128, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESKey128));
		intern->len = sizeof(TAESKey128);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESKey128, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESKey128));
}

zend_class_entry *TAESKey128_ce_ptr = NULL;

static zend_function_entry TAESKey128_methods[] = {
	PHP_ME(TAESKey128, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESKey128, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESKey128(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESKey128_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESKey128", TAESKey128_methods);
	TAESKey128_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESExpandedKey128, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESExpandedKey128));
		intern->len = sizeof(TAESExpandedKey128);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESExpandedKey128, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESExpandedKey128));
}

zend_class_entry *TAESExpandedKey128_ce_ptr = NULL;

static zend_function_entry TAESExpandedKey128_methods[] = {
	PHP_ME(TAESExpandedKey128, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESExpandedKey128, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESExpandedKey128(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESExpandedKey128_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESExpandedKey128", TAESExpandedKey128_methods);
	TAESExpandedKey128_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESKey192, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESKey192));
		intern->len = sizeof(TAESKey192);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESKey192, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESKey192));
}

zend_class_entry *TAESKey192_ce_ptr = NULL;

static zend_function_entry TAESKey192_methods[] = {
	PHP_ME(TAESKey192, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESKey192, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESKey192(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESKey192_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESKey192", TAESKey192_methods);
	TAESKey192_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESExpandedKey192, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESExpandedKey192));
		intern->len = sizeof(TAESExpandedKey192);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESExpandedKey192, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESExpandedKey192));
}

zend_class_entry *TAESExpandedKey192_ce_ptr = NULL;

static zend_function_entry TAESExpandedKey192_methods[] = {
	PHP_ME(TAESExpandedKey192, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESExpandedKey192, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESExpandedKey192(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESExpandedKey192_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESExpandedKey192", TAESExpandedKey192_methods);
	TAESExpandedKey192_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESKey256, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESKey256));
		intern->len = sizeof(TAESKey256);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESKey256, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESKey256));
}

zend_class_entry *TAESKey256_ce_ptr = NULL;

static zend_function_entry TAESKey256_methods[] = {
	PHP_ME(TAESKey256, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESKey256, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESKey256(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESKey256_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESKey256", TAESKey256_methods);
	TAESKey256_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TAESExpandedKey256, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TAESExpandedKey256));
		intern->len = sizeof(TAESExpandedKey256);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TAESExpandedKey256, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TAESExpandedKey256));
}

zend_class_entry *TAESExpandedKey256_ce_ptr = NULL;

static zend_function_entry TAESExpandedKey256_methods[] = {
	PHP_ME(TAESExpandedKey256, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TAESExpandedKey256, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TAESExpandedKey256(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAESExpandedKey256_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TAESExpandedKey256", TAESExpandedKey256_methods);
	TAESExpandedKey256_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForEncryption128)
{
	zval *oExpandedKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oKey, TAESKey128_ce_ptr, &oExpandedKey, TAESExpandedKey128_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForEncryption128((TAESKey128 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESExpandedKey128 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TAESKey128, &TAESExpandedKey128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForEncryption192)
{
	zval *oExpandedKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oKey, TAESKey192_ce_ptr, &oExpandedKey, TAESExpandedKey192_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForEncryption192((TAESKey192 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESExpandedKey192 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TAESKey192, &TAESExpandedKey192)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForEncryption256)
{
	zval *oExpandedKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oKey, TAESKey256_ce_ptr, &oExpandedKey, TAESExpandedKey256_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForEncryption256((TAESKey256 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESExpandedKey256 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TAESKey256, &TAESExpandedKey256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForDecryption128)
{
	zval *oExpandedKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oExpandedKey, TAESExpandedKey128_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForDecryption128((TAESExpandedKey128 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TAESExpandedKey128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForDecryption192)
{
	zval *oExpandedKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oExpandedKey, TAESExpandedKey192_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForDecryption192((TAESExpandedKey192 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TAESExpandedKey192)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, ExpandKeyForDecryption256)
{
	zval *oExpandedKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oExpandedKey, TAESExpandedKey256_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBAES_ExpandKeyForDecryption256((TAESExpandedKey256 *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TAESExpandedKey256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Encrypt128)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey128_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Encrypt128((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey128 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey128_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Encrypt128_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey128 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey128, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Encrypt192)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey192_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Encrypt192((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey192 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey192_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Encrypt192_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey192 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey192, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey192)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Encrypt256)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey256_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Encrypt256((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey256 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey256_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Encrypt256_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey256 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey256, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Decrypt128)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey128_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Decrypt128((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey128 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey128_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Decrypt128_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey128 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey128, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Decrypt192)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey192_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Decrypt192((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey192 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey192_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Decrypt192_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey192 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey192, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey192)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBAES, Decrypt256)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oInBuf;
	zval *oKey;
	zval *oOutBuf;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOO", &oInBuf, TAESBuffer_ce_ptr, &oKey, TAESExpandedKey256_ce_ptr, &oOutBuf, TAESBuffer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutBuf))
	{
		SBCheckError(SBAES_Decrypt256((TAESBuffer *)SBGetStructPointer(oInBuf TSRMLS_CC), (TAESExpandedKey256 *)SBGetStructPointer(oKey TSRMLS_CC), (TAESBuffer *)SBGetStructPointer(oOutBuf TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TAESExpandedKey256_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBAES_Decrypt256_1(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TAESExpandedKey256 *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TAESBuffer, TAESExpandedKey256, &TAESBuffer) or (&integer, &integer, &integer, &integer, TAESExpandedKey256)" TSRMLS_CC);
	}
}

void Register_SBAES_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBAES, TAESBufferSize, SB_TAESBufferSize, SB_TAESBufferSize);
}

