#include "sbcmsutils.h"

void SB_CALLBACK TSBCMSCertificateNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElCertificateLookupHandle Lookup, TElX509CertificateHandle * Cert)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zLookup;
	zval * zCert;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zLookup);
	SBInitObject(zLookup, TElCertificateLookup_ce_ptr, Lookup TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, *Cert TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zLookup;
	params[2] = &zCert;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zLookup);
	*Cert = SBGetObjectHandleCE(zCert, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCert TSRMLS_CC);
	zval_ptr_dtor(&zCert);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

