#include "sbcustomfsadapter.h"

zend_class_entry *TSBFileShareMode_ce_ptr = NULL;

zend_class_entry *TSBFileType_ce_ptr = NULL;

zend_class_entry *TSBFileSeekOrigin_ce_ptr = NULL;

zend_class_entry *TElVFSEntryInformation_ce_ptr = NULL;

SB_PHP_METHOD(TElVFSEntryInformation, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElVFSEntryInformation_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElVFSEntryInformation)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_AccessMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_AccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_AccessMode)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_AccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_Attributes)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_DateAccessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_DateAccessed(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_DateAccessed)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_DateAccessed(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_DateCreated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_DateCreated(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_DateCreated)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_DateCreated(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_DateModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_DateModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_DateModified)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_DateModified(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_FileType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFileTypeRaw fOutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_FileType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFileTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElVFSEntryInformation_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-238316360, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_FullName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElVFSEntryInformation_get_FullName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1727682866, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_FullName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_FullName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_OwnerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElVFSEntryInformation_get_OwnerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1120409474, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_OwnerName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_OwnerName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElVFSEntryInformation_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, set_Size)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformation_set_Size(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVFSEntryInformation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElVFSEntryInformation, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_AccessMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_AccessMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_DateAccessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_DateAccessed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_DateCreated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_DateCreated, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_DateModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_DateModified, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_FileType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_FileType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_FullName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_FullName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_OwnerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_OwnerName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation_set_Size, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElVFSEntryInformation_methods[] = {
	PHP_ME(TElVFSEntryInformation, Assign, arginfo_TElVFSEntryInformation_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_AccessMode, arginfo_TElVFSEntryInformation_get_AccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_AccessMode, arginfo_TElVFSEntryInformation_set_AccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_Attributes, arginfo_TElVFSEntryInformation_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_Attributes, arginfo_TElVFSEntryInformation_set_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_DateAccessed, arginfo_TElVFSEntryInformation_get_DateAccessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_DateAccessed, arginfo_TElVFSEntryInformation_set_DateAccessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_DateCreated, arginfo_TElVFSEntryInformation_get_DateCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_DateCreated, arginfo_TElVFSEntryInformation_set_DateCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_DateModified, arginfo_TElVFSEntryInformation_get_DateModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_DateModified, arginfo_TElVFSEntryInformation_set_DateModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_FileType, arginfo_TElVFSEntryInformation_get_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_FileType, arginfo_TElVFSEntryInformation_set_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_Name, arginfo_TElVFSEntryInformation_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_Name, arginfo_TElVFSEntryInformation_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_FullName, arginfo_TElVFSEntryInformation_get_FullName, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_FullName, arginfo_TElVFSEntryInformation_set_FullName, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_OwnerName, arginfo_TElVFSEntryInformation_get_OwnerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_OwnerName, arginfo_TElVFSEntryInformation_set_OwnerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, get_Size, arginfo_TElVFSEntryInformation_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, set_Size, arginfo_TElVFSEntryInformation_set_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformation, __construct, arginfo_TElVFSEntryInformation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVFSEntryInformation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVFSEntryInformation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVFSEntryInformation", TElVFSEntryInformation_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElVFSEntryInformation_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElVFSEntryInformationList_ce_ptr = NULL;

SB_PHP_METHOD(TElVFSEntryInformationList, Add)
{
	zval *oItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TElVFSEntryInformation_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformationList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElVFSEntryInformation)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformationList, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElVFSEntryInformationList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformationList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElVFSEntryInformationList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformationList, get_Item)
{
	long l4index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVFSEntryInformationList_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElVFSEntryInformation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVFSEntryInformationList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVFSEntryInformationList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformationList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Item, TElVFSEntryInformation, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformationList_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformationList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformationList_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVFSEntryInformationList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElVFSEntryInformationList_methods[] = {
	PHP_ME(TElVFSEntryInformationList, Add, arginfo_TElVFSEntryInformationList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformationList, Remove, arginfo_TElVFSEntryInformationList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformationList, get_Count, arginfo_TElVFSEntryInformationList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformationList, get_Item, arginfo_TElVFSEntryInformationList_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElVFSEntryInformationList, __construct, arginfo_TElVFSEntryInformationList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVFSEntryInformationList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVFSEntryInformationList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVFSEntryInformationList", TElVFSEntryInformationList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElVFSEntryInformationList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomFileSystemAdapter_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomFileSystemAdapter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomFileSystemAdapter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, NameMatchesMask)
{
	char *sMask;
	char *sPath;
	int sMask_len;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPath, &sPath_len, &sMask, &sMask_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_NameMatchesMask(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sMask, (int32_t)sMask_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, GetFileStream)
{
	char *sPath;
	int sPath_len;
	long fShareMode;
	long u4OpenMode;
	TElClassHandle hoFileStream;
	zval *oFileStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllO", &sPath, &sPath_len, &u4OpenMode, &fShareMode, &oFileStream, TStream_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oFileStream) && (IS_OBJECT == Z_TYPE_P(oFileStream)))
	{
		int32_t l4OutResultRaw = 0;
		hoFileStream = SBGetObjectHandle(oFileStream TSRMLS_CC);
		SBCheckError(TElCustomFileSystemAdapter_GetFileStream(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (uint32_t)u4OpenMode, (TSBFileShareModeRaw)fShareMode, &hoFileStream, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oFileStream, hoFileStream TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, &TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileOpen)
{
	char *sPath;
	int sPath_len;
	long fShareMode;
	long u4OpenMode;
	TElClassHandle hoFileHandle;
	zval *oFileHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllO", &sPath, &sPath_len, &u4OpenMode, &fShareMode, &oFileHandle, TObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oFileHandle) && (IS_OBJECT == Z_TYPE_P(oFileHandle)))
	{
		int32_t l4OutResultRaw = 0;
		hoFileHandle = SBGetObjectHandle(oFileHandle TSRMLS_CC);
		SBCheckError(TElCustomFileSystemAdapter_FileOpen(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (uint32_t)u4OpenMode, (TSBFileShareModeRaw)fShareMode, &hoFileHandle, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oFileHandle, hoFileHandle TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, &TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileClose)
{
	zval *oFileHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFileHandle, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomFileSystemAdapter_FileClose(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, CloseAllFiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomFileSystemAdapter_CloseAllFiles(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileExists)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, DirectoryExists)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_DirectoryExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileRead)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *oFileHandle;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zll", &oFileHandle, TObject_ce_ptr, &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomFileSystemAdapter_FileRead(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileWrite)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *oFileHandle;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zll", &oFileHandle, TObject_ce_ptr, &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomFileSystemAdapter_FileWrite(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileGetSize)
{
	zval *oFileHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFileHandle, TObject_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileGetSize(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileSetSize)
{
	long l8NewSize;
	zval *oFileHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oFileHandle, TObject_ce_ptr, &l8NewSize) == SUCCESS)
	{
		SBCheckError(TElCustomFileSystemAdapter_FileSetSize(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), (int64_t)l8NewSize) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileGetPosition)
{
	zval *oFileHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFileHandle, TObject_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileGetPosition(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileSeek)
{
	long fOrigin;
	long l8Position;
	zval *oFileHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oFileHandle, TObject_ce_ptr, &l8Position, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileSeek(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFileHandle TSRMLS_CC), (int64_t)l8Position, (TSBFileSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileGetTimes)
{
	char *sPath;
	int sPath_len;
	int64_t dtCreationTimeRaw;
	int64_t dtLastAccessTimeRaw;
	int64_t dtModificationTimeRaw;
	zval *dtCreationTime;
	zval *dtLastAccessTime;
	zval *dtModificationTime;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOOO", &sPath, &sPath_len, &dtCreationTime, php_date_get_date_ce(), &dtModificationTime, php_date_get_date_ce(), &dtLastAccessTime, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(dtCreationTime) && PZVAL_IS_REF(dtModificationTime) && PZVAL_IS_REF(dtLastAccessTime))
	{
		int32_t l4OutResultRaw = 0;
		dtCreationTimeRaw = SBGetDateTime(dtCreationTime TSRMLS_CC);
		dtModificationTimeRaw = SBGetDateTime(dtModificationTime TSRMLS_CC);
		dtLastAccessTimeRaw = SBGetDateTime(dtLastAccessTime TSRMLS_CC);
		SBCheckError(TElCustomFileSystemAdapter_FileGetTimes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &dtCreationTimeRaw, &dtModificationTimeRaw, &dtLastAccessTimeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBSetDateTime(dtCreationTime, dtCreationTimeRaw TSRMLS_CC);
		SBSetDateTime(dtModificationTime, dtModificationTimeRaw TSRMLS_CC);
		SBSetDateTime(dtLastAccessTime, dtLastAccessTimeRaw TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &DateTime, &DateTime, &DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileSetTimes)
{
	char *sPath;
	int sPath_len;
	zval *dtCreationTime;
	zval *dtLastAccessTime;
	zval *dtModificationTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOOO", &sPath, &sPath_len, &dtCreationTime, php_date_get_date_ce(), &dtModificationTime, php_date_get_date_ce(), &dtLastAccessTime, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileSetTimes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetDateTime(dtCreationTime TSRMLS_CC), SBGetDateTime(dtModificationTime TSRMLS_CC), SBGetDateTime(dtLastAccessTime TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, DateTime, DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileDelete)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileDelete(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileMove)
{
	char *sFromName;
	char *sToName;
	int sFromName_len;
	int sToName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFromName, &sFromName_len, &sToName, &sToName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileMove(SBGetObjectHandle(getThis() TSRMLS_CC), sFromName, (int32_t)sFromName_len, sToName, (int32_t)sToName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, FileCopy)
{
	char *sFromName;
	char *sToName;
	int sFromName_len;
	int sToName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFromName, &sFromName_len, &sToName, &sToName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_FileCopy(SBGetObjectHandle(getThis() TSRMLS_CC), sFromName, (int32_t)sFromName_len, sToName, (int32_t)sToName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, WriteFileTag)
{
	char *sPath;
	char *sTagName;
	char *sTagValue;
	int sPath_len;
	int sTagName_len;
	int sTagValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sPath, &sPath_len, &sTagName, &sTagName_len, &sTagValue, &sTagValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_WriteFileTag(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sTagName, (int32_t)sTagName_len, sTagValue, (int32_t)sTagValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, ReadFileTag)
{
	char *sPath;
	char *sTagName;
	char *sTagValue;
	int sPath_len;
	int sTagName_len;
	int32_t sTagValue_len;
	uint32_t _err;
	zval *zsTagValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &sPath, &sPath_len, &sTagName, &sTagName_len, &zsTagValue) == SUCCESS) && PZVAL_IS_REF(zsTagValue) && (IS_STRING == Z_TYPE_P(zsTagValue)))
	{
		int32_t l4OutResultRaw = 0;
		sTagValue = Z_STRVAL_P(zsTagValue);
		sTagValue_len = (int32_t)Z_STRLEN_P(zsTagValue);
		_err = TElCustomFileSystemAdapter_ReadFileTag(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sTagName, (int32_t)sTagName_len, sTagValue, &sTagValue_len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sTagValue = emalloc(sTagValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(1753297687, 3, sTagValue, &sTagValue_len) TSRMLS_CC);
			zval_dtor(zsTagValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sTagValue[sTagValue_len] = 0;
		ZVAL_STRINGL(zsTagValue, sTagValue, sTagValue_len, 0);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, DeleteFileTag)
{
	char *sPath;
	char *sTagName;
	int sPath_len;
	int sTagName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPath, &sPath_len, &sTagName, &sTagName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_DeleteFileTag(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sTagName, (int32_t)sTagName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, DirectoryMake)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_DirectoryMake(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, DirectoryRemove)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_DirectoryRemove(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, EnumDirectoryEntries)
{
	char *sMask;
	char *sPath;
	int sMask_len;
	int sPath_len;
	TElClassHandle hoEntryInfos = SB_NULL_HANDLE;
	zend_bool bRecursive;
	zval *oEntryInfos;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO", &sPath, &sPath_len, &sMask, &sMask_len, &bRecursive, &oEntryInfos, TElVFSEntryInformationList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oEntryInfos) && (IS_OBJECT == Z_TYPE_P(oEntryInfos)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_EnumDirectoryEntries(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sMask, (int32_t)sMask_len, (int8_t)bRecursive, &hoEntryInfos, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oEntryInfos, hoEntryInfos TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, &TElVFSEntryInformationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, GetEntryInformation)
{
	char *sPath;
	int sPath_len;
	zval *oEntryInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oEntryInfo, TElVFSEntryInformation_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_GetEntryInformation(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oEntryInfo TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElVFSEntryInformation)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, SetEntryInformation)
{
	char *sPath;
	int sPath_len;
	long l4InfoFlags;
	zval *oEntryInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sPath, &sPath_len, &oEntryInfo, TElVFSEntryInformation_ce_ptr, &l4InfoFlags) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_SetEntryInformation(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oEntryInfo TSRMLS_CC), (int32_t)l4InfoFlags, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElVFSEntryInformation, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, IsAccessible)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_IsAccessible(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, get_CaseSensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomFileSystemAdapter_get_CaseSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, set_CaseSensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomFileSystemAdapter_set_CaseSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, get_BasePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomFileSystemAdapter_get_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1559100536, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, set_BasePath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomFileSystemAdapter_set_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, get_PathSeparator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElCustomFileSystemAdapter_get_PathSeparator(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, set_PathSeparator)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElCustomFileSystemAdapter_set_PathSeparator(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, get_PathSeparator2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElCustomFileSystemAdapter_get_PathSeparator2(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, set_PathSeparator2)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElCustomFileSystemAdapter_set_PathSeparator2(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomFileSystemAdapter, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomFileSystemAdapter_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_NameMatchesMask, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Mask)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_GetFileStream, 0, 0, 4)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, OpenMode)
	ZEND_ARG_INFO(0, ShareMode)
	ZEND_ARG_OBJ_INFO(1, FileStream, TStream, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileOpen, 0, 0, 4)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, OpenMode)
	ZEND_ARG_INFO(0, ShareMode)
	ZEND_ARG_OBJ_INFO(1, FileHandle, TObject, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileClose, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_CloseAllFiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_DirectoryExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileRead, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileWrite, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileGetSize, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileSetSize, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
	ZEND_ARG_INFO(0, NewSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileGetPosition, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileSeek, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, FileHandle, TObject, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileGetTimes, 0, 0, 4)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(1, CreationTime, DateTime, 0)
	ZEND_ARG_OBJ_INFO(1, ModificationTime, DateTime, 0)
	ZEND_ARG_OBJ_INFO(1, LastAccessTime, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileSetTimes, 0, 0, 4)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, CreationTime, DateTime, 0)
	ZEND_ARG_OBJ_INFO(0, ModificationTime, DateTime, 0)
	ZEND_ARG_OBJ_INFO(0, LastAccessTime, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileDelete, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileMove, 0, 0, 2)
	ZEND_ARG_INFO(0, FromName)
	ZEND_ARG_INFO(0, ToName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_FileCopy, 0, 0, 2)
	ZEND_ARG_INFO(0, FromName)
	ZEND_ARG_INFO(0, ToName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_WriteFileTag, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, TagName)
	ZEND_ARG_INFO(0, TagValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_ReadFileTag, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, TagName)
	ZEND_ARG_INFO(1, TagValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_DeleteFileTag, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, TagName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_DirectoryMake, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_DirectoryRemove, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_EnumDirectoryEntries, 0, 0, 4)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Mask)
	ZEND_ARG_INFO(0, Recursive)
	ZEND_ARG_OBJ_INFO(1, EntryInfos, TElVFSEntryInformationList, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_GetEntryInformation, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, EntryInfo, TElVFSEntryInformation, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_SetEntryInformation, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, EntryInfo, TElVFSEntryInformation, 1)
	ZEND_ARG_INFO(0, InfoFlags)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_IsAccessible, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_get_CaseSensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_set_CaseSensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_get_BasePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_set_BasePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_get_PathSeparator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_set_PathSeparator, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_get_PathSeparator2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter_set_PathSeparator2, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomFileSystemAdapter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomFileSystemAdapter_methods[] = {
	PHP_ME(TElCustomFileSystemAdapter, Clone, arginfo_TElCustomFileSystemAdapter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, NameMatchesMask, arginfo_TElCustomFileSystemAdapter_NameMatchesMask, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, GetFileStream, arginfo_TElCustomFileSystemAdapter_GetFileStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileOpen, arginfo_TElCustomFileSystemAdapter_FileOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileClose, arginfo_TElCustomFileSystemAdapter_FileClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, CloseAllFiles, arginfo_TElCustomFileSystemAdapter_CloseAllFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileExists, arginfo_TElCustomFileSystemAdapter_FileExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, DirectoryExists, arginfo_TElCustomFileSystemAdapter_DirectoryExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileRead, arginfo_TElCustomFileSystemAdapter_FileRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileWrite, arginfo_TElCustomFileSystemAdapter_FileWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileGetSize, arginfo_TElCustomFileSystemAdapter_FileGetSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileSetSize, arginfo_TElCustomFileSystemAdapter_FileSetSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileGetPosition, arginfo_TElCustomFileSystemAdapter_FileGetPosition, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileSeek, arginfo_TElCustomFileSystemAdapter_FileSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileGetTimes, arginfo_TElCustomFileSystemAdapter_FileGetTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileSetTimes, arginfo_TElCustomFileSystemAdapter_FileSetTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileDelete, arginfo_TElCustomFileSystemAdapter_FileDelete, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileMove, arginfo_TElCustomFileSystemAdapter_FileMove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, FileCopy, arginfo_TElCustomFileSystemAdapter_FileCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, WriteFileTag, arginfo_TElCustomFileSystemAdapter_WriteFileTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, ReadFileTag, arginfo_TElCustomFileSystemAdapter_ReadFileTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, DeleteFileTag, arginfo_TElCustomFileSystemAdapter_DeleteFileTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, DirectoryMake, arginfo_TElCustomFileSystemAdapter_DirectoryMake, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, DirectoryRemove, arginfo_TElCustomFileSystemAdapter_DirectoryRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, EnumDirectoryEntries, arginfo_TElCustomFileSystemAdapter_EnumDirectoryEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, GetEntryInformation, arginfo_TElCustomFileSystemAdapter_GetEntryInformation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, SetEntryInformation, arginfo_TElCustomFileSystemAdapter_SetEntryInformation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, IsAccessible, arginfo_TElCustomFileSystemAdapter_IsAccessible, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, get_CaseSensitive, arginfo_TElCustomFileSystemAdapter_get_CaseSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, set_CaseSensitive, arginfo_TElCustomFileSystemAdapter_set_CaseSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, get_BasePath, arginfo_TElCustomFileSystemAdapter_get_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, set_BasePath, arginfo_TElCustomFileSystemAdapter_set_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, get_PathSeparator, arginfo_TElCustomFileSystemAdapter_get_PathSeparator, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, set_PathSeparator, arginfo_TElCustomFileSystemAdapter_set_PathSeparator, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, get_PathSeparator2, arginfo_TElCustomFileSystemAdapter_get_PathSeparator2, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, set_PathSeparator2, arginfo_TElCustomFileSystemAdapter_set_PathSeparator2, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomFileSystemAdapter, __construct, arginfo_TElCustomFileSystemAdapter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomFileSystemAdapter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomFileSystemAdapter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomFileSystemAdapter", TElCustomFileSystemAdapter_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomFileSystemAdapter_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCustomFSAdapter, RaiseVFSAdapterError)
{
	char *sFileName;
	int sFileName_len;
	long l4ErrorCode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4ErrorCode, &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(SBCustomFSAdapter_RaiseVFSAdapterError((int32_t)l4ErrorCode, sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCustomFSAdapter, RaiseVFSAdapterErrorEx)
{
	char *sFileName;
	int sFileName_len;
	long l4ErrorCode;
	zval *oAdapter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oAdapter, TElCustomFileSystemAdapter_ce_ptr, &l4ErrorCode, &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(SBCustomFSAdapter_RaiseVFSAdapterErrorEx(SBGetObjectHandle(oAdapter TSRMLS_CC), (int32_t)l4ErrorCode, sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter, integer, string)" TSRMLS_CC);
	}
}

void Register_SBCustomFSAdapter_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileOpenRead, SB_fileOpenRead, SB_fileOpenRead);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileOpenWrite, SB_fileOpenWrite, SB_fileOpenWrite);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileOpenCreate, SB_fileOpenCreate, SB_fileOpenCreate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileOpenAppend, SB_fileOpenAppend, SB_fileOpenAppend);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileOpenTruncate, SB_fileOpenTruncate, SB_fileOpenTruncate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileAttributeReadonly, SB_fileAttributeReadonly, SB_fileAttributeReadonly);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileAttributeHidden, SB_fileAttributeHidden, SB_fileAttributeHidden);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileAttributeSystem, SB_fileAttributeSystem, SB_fileAttributeSystem);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileAttributeArchive, SB_fileAttributeArchive, SB_fileAttributeArchive);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, fileAttributeSymlink, SB_fileAttributeSymlink, SB_fileAttributeSymlink);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, entryInfoAttributes, SB_entryInfoAttributes, SB_entryInfoAttributes);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, entryInfoModifyDate, SB_entryInfoModifyDate, SB_entryInfoModifyDate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, entryInfoCreateDate, SB_entryInfoCreateDate, SB_entryInfoCreateDate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, entryInfoAccessDate, SB_entryInfoAccessDate, SB_entryInfoAccessDate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, entryInfoAllFileDate, SB_entryInfoAllFileDate, SB_entryInfoAllFileDate);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, ERROR_FACILITY_VFS, SB_ERROR_FACILITY_VFS, SB_ERROR_FACILITY_VFS);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, ERROR_VFS_ERROR_FLAG, SB_ERROR_VFS_ERROR_FLAG, SB_ERROR_VFS_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, ERROR_VFS_CUSTOM_ERROR_FLAG, SB_ERROR_VFS_CUSTOM_ERROR_FLAG, SB_ERROR_VFS_CUSTOM_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_NO_ERROR, SB_VFS_ERROR_NO_ERROR, SB_VFS_ERROR_NO_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_FILE_NOT_FOUND, SB_VFS_ERROR_FILE_NOT_FOUND, SB_VFS_ERROR_FILE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_PATH_NOT_FOUND, SB_VFS_ERROR_PATH_NOT_FOUND, SB_VFS_ERROR_PATH_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_ACCESS_DENIED, SB_VFS_ERROR_ACCESS_DENIED, SB_VFS_ERROR_ACCESS_DENIED);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_WRITE_PROTECT, SB_VFS_ERROR_WRITE_PROTECT, SB_VFS_ERROR_WRITE_PROTECT);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_ERROR_CRC, SB_VFS_ERROR_ERROR_CRC, SB_VFS_ERROR_ERROR_CRC);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_NOT_SUPPORTED, SB_VFS_ERROR_NOT_SUPPORTED, SB_VFS_ERROR_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_INVALID_PARAMETER, SB_VFS_ERROR_INVALID_PARAMETER, SB_VFS_ERROR_INVALID_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_ERROR_NO_MEDIA, SB_VFS_ERROR_NO_MEDIA, SB_VFS_ERROR_NO_MEDIA);
	SB_REGISTER_LONG_CONSTANT(SBCustomFSAdapter, SB_VFS_UNSPECIFIED_ERROR, SB_VFS_UNSPECIFIED_ERROR, SB_VFS_UNSPECIFIED_ERROR);
	SB_REGISTER_STRING_CONSTANT(SBCustomFSAdapter, SFileSystemOperationFailed, SB_SFileSystemOperationFailed, SB_SFileSystemOperationFailed);
}

void Register_SBCustomFSAdapter_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBFileShareMode", NULL);
	TSBFileShareMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFileShareMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFileShareMode_ce_ptr, "ssmExclusive", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileShareMode_ce_ptr, "ssmDenyRead", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileShareMode_ce_ptr, "ssmDenyWrite", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileShareMode_ce_ptr, "ssmNone", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBFileType", NULL);
	TSBFileType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFileType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFileType_ce_ptr, "sftUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileType_ce_ptr, "sftFile", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileType_ce_ptr, "sftDirectory", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileType_ce_ptr, "sftSymLink", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBFileSeekOrigin", NULL);
	TSBFileSeekOrigin_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFileSeekOrigin_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFileSeekOrigin_ce_ptr, "sfsoBegin", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileSeekOrigin_ce_ptr, "sfsoCurrent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileSeekOrigin_ce_ptr, "sfsoEnd", 2)
}

void Register_SBCustomFSAdapter_Aliases(TSRMLS_D)
{
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	zend_register_class_alias("TElVFSHandle", TObject_ce_ptr);
}

