#include "sbgost341001.h"

SB_PHP_FUNCTION(SBGOST341001, Generate)
{
	int32_t l4DSizeRaw;
	int32_t l4QxSizeRaw;
	int32_t l4QySizeRaw;
	long l4ASize;
	long l4BSize;
	long l4Fld;
	long l4NSize;
	long l4PSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo piD;
	SBArrayZValInfo piN;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQx;
	SBArrayZValInfo piQy;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4DSize;
	zval *zl4QxSize;
	zval *zl4QySize;
	zval *zpA;
	zval *zpB;
	zval *zpD;
	zval *zpN;
	zval *zpP;
	zval *zpQx;
	zval *zpQy;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzllzzzzzz", &zpA, &l4ASize, &zpB, &l4BSize, &zpX, &l4XSize, &zpY, &l4YSize, &zpN, &l4NSize, &zpP, &l4PSize, &l4Fld, &zpD, &zl4DSize, &zpQx, &zl4QxSize, &zpQy, &zl4QySize) == SUCCESS) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DSize) && (IS_LONG == Z_TYPE_P(zl4DSize)) && ((Z_TYPE_P(zpQx) == IS_STRING) || (Z_TYPE_P(zpQx) == IS_ARRAY) || (Z_TYPE_P(zpQx) == IS_NULL) || ((Z_TYPE_P(zpQx) == IS_OBJECT) && (Z_OBJCE_P(zpQx) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QxSize) && (IS_LONG == Z_TYPE_P(zl4QxSize)) && ((Z_TYPE_P(zpQy) == IS_STRING) || (Z_TYPE_P(zpQy) == IS_ARRAY) || (Z_TYPE_P(zpQy) == IS_NULL) || ((Z_TYPE_P(zpQy) == IS_OBJECT) && (Z_OBJCE_P(zpQy) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QySize) && (IS_LONG == Z_TYPE_P(zl4QySize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		l4DSizeRaw = (int32_t)Z_LVAL_P(zl4DSize);
		if (!SBGetPointerFromZVal(zpQx, &piQx TSRMLS_CC)) RETURN_FALSE;
		l4QxSizeRaw = (int32_t)Z_LVAL_P(zl4QxSize);
		if (!SBGetPointerFromZVal(zpQy, &piQy TSRMLS_CC)) RETURN_FALSE;
		l4QySizeRaw = (int32_t)Z_LVAL_P(zl4QySize);
		SBCheckError(SBGOST341001_Generate(piA.data, (int32_t)l4ASize, piB.data, (int32_t)l4BSize, piX.data, (int32_t)l4XSize, piY.data, (int32_t)l4YSize, piN.data, (int32_t)l4NSize, piP.data, (int32_t)l4PSize, (int32_t)l4Fld, piD.data, &l4DSizeRaw, piQx.data, &l4QxSizeRaw, piQy.data, &l4QySizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piB);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piD);
		ZVAL_LONG(zl4DSize, (long)l4DSizeRaw);
		SBFreePointerZValInfo(&piQx);
		ZVAL_LONG(zl4QxSize, (long)l4QxSizeRaw);
		SBFreePointerZValInfo(&piQy);
		ZVAL_LONG(zl4QySize, (long)l4QySizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST341001, Sign)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4ASize;
	long l4BSize;
	long l4dSize;
	long l4Fld;
	long l4hashSize;
	long l4NSize;
	long l4PSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo pid;
	SBArrayZValInfo pihash;
	SBArrayZValInfo piN;
	SBArrayZValInfo piP;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpA;
	zval *zpB;
	zval *zpd;
	zval *zphash;
	zval *zpN;
	zval *zpP;
	zval *zpR;
	zval *zpS;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzlzllzzzz", &zphash, &l4hashSize, &zpd, &l4dSize, &zpA, &l4ASize, &zpB, &l4BSize, &zpX, &l4XSize, &zpY, &l4YSize, &zpN, &l4NSize, &zpP, &l4PSize, &l4Fld, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zphash) == IS_STRING) || (Z_TYPE_P(zphash) == IS_ARRAY) || (Z_TYPE_P(zphash) == IS_NULL) || ((Z_TYPE_P(zphash) == IS_OBJECT) && (Z_OBJCE_P(zphash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpd) == IS_STRING) || (Z_TYPE_P(zpd) == IS_ARRAY) || (Z_TYPE_P(zpd) == IS_NULL) || ((Z_TYPE_P(zpd) == IS_OBJECT) && (Z_OBJCE_P(zpd) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zphash, &pihash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpd, &pid TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBGOST341001_Sign(pihash.data, (int32_t)l4hashSize, pid.data, (int32_t)l4dSize, piA.data, (int32_t)l4ASize, piB.data, (int32_t)l4BSize, piX.data, (int32_t)l4XSize, piY.data, (int32_t)l4YSize, piN.data, (int32_t)l4NSize, piP.data, (int32_t)l4PSize, (int32_t)l4Fld, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&pihash);
		SBFreePointerZValInfo(&pid);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piB);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST341001, Verify)
{
	long l4ASize;
	long l4BSize;
	long l4Fld;
	long l4hashSize;
	long l4NSize;
	long l4PSize;
	long l4QxSize;
	long l4QySize;
	long l4RSize;
	long l4SSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo pihash;
	SBArrayZValInfo piN;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQx;
	SBArrayZValInfo piQy;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zpA;
	zval *zpB;
	zval *zphash;
	zval *zpN;
	zval *zpP;
	zval *zpQx;
	zval *zpQy;
	zval *zpR;
	zval *zpS;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzlzlzlzlzll", &zphash, &l4hashSize, &zpQx, &l4QxSize, &zpQy, &l4QySize, &zpR, &l4RSize, &zpS, &l4SSize, &zpA, &l4ASize, &zpB, &l4BSize, &zpX, &l4XSize, &zpY, &l4YSize, &zpN, &l4NSize, &zpP, &l4PSize, &l4Fld) == SUCCESS) && ((Z_TYPE_P(zphash) == IS_STRING) || (Z_TYPE_P(zphash) == IS_ARRAY) || (Z_TYPE_P(zphash) == IS_NULL) || ((Z_TYPE_P(zphash) == IS_OBJECT) && (Z_OBJCE_P(zphash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQx) == IS_STRING) || (Z_TYPE_P(zpQx) == IS_ARRAY) || (Z_TYPE_P(zpQx) == IS_NULL) || ((Z_TYPE_P(zpQx) == IS_OBJECT) && (Z_OBJCE_P(zpQx) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQy) == IS_STRING) || (Z_TYPE_P(zpQy) == IS_ARRAY) || (Z_TYPE_P(zpQy) == IS_NULL) || ((Z_TYPE_P(zpQy) == IS_OBJECT) && (Z_OBJCE_P(zpQy) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zphash, &pihash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQx, &piQx TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQy, &piQy TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBGOST341001_Verify(pihash.data, (int32_t)l4hashSize, piQx.data, (int32_t)l4QxSize, piQy.data, (int32_t)l4QySize, piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piA.data, (int32_t)l4ASize, piB.data, (int32_t)l4BSize, piX.data, (int32_t)l4XSize, piY.data, (int32_t)l4YSize, piN.data, (int32_t)l4NSize, piP.data, (int32_t)l4PSize, (int32_t)l4Fld, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&pihash);
		SBFreePointerZValInfo(&piQx);
		SBFreePointerZValInfo(&piQy);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piB);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piP);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST341001, DeriveKey)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4ASize;
	long l4BSize;
	long l4DSize;
	long l4Fld;
	long l4NSize;
	long l4PSize;
	long l4QxSize;
	long l4QySize;
	long l4ukmSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo piD;
	SBArrayZValInfo piN;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQx;
	SBArrayZValInfo piQy;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piukm;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpA;
	zval *zpB;
	zval *zpD;
	zval *zpN;
	zval *zpP;
	zval *zpQx;
	zval *zpQy;
	zval *zpR;
	zval *zpS;
	zval *zpukm;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzlzlzlzllzzzz", &zpukm, &l4ukmSize, &zpD, &l4DSize, &zpQx, &l4QxSize, &zpQy, &l4QySize, &zpA, &l4ASize, &zpB, &l4BSize, &zpX, &l4XSize, &zpY, &l4YSize, &zpN, &l4NSize, &zpP, &l4PSize, &l4Fld, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpukm) == IS_STRING) || (Z_TYPE_P(zpukm) == IS_ARRAY) || (Z_TYPE_P(zpukm) == IS_NULL) || ((Z_TYPE_P(zpukm) == IS_OBJECT) && (Z_OBJCE_P(zpukm) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQx) == IS_STRING) || (Z_TYPE_P(zpQx) == IS_ARRAY) || (Z_TYPE_P(zpQx) == IS_NULL) || ((Z_TYPE_P(zpQx) == IS_OBJECT) && (Z_OBJCE_P(zpQx) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQy) == IS_STRING) || (Z_TYPE_P(zpQy) == IS_ARRAY) || (Z_TYPE_P(zpQy) == IS_NULL) || ((Z_TYPE_P(zpQy) == IS_OBJECT) && (Z_OBJCE_P(zpQy) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpukm, &piukm TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQx, &piQx TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQy, &piQy TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBGOST341001_DeriveKey(piukm.data, (int32_t)l4ukmSize, piD.data, (int32_t)l4DSize, piQx.data, (int32_t)l4QxSize, piQy.data, (int32_t)l4QySize, piA.data, (int32_t)l4ASize, piB.data, (int32_t)l4BSize, piX.data, (int32_t)l4XSize, piY.data, (int32_t)l4YSize, piN.data, (int32_t)l4NSize, piP.data, (int32_t)l4PSize, (int32_t)l4Fld, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piukm);
		SBFreePointerZValInfo(&piD);
		SBFreePointerZValInfo(&piQx);
		SBFreePointerZValInfo(&piQy);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piB);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

