#include "sbsmimecore.h"

zend_class_entry *TElSMimeBoolState_ce_ptr = NULL;

zend_class_entry *TElSMimeType_ce_ptr = NULL;

zend_class_entry *TElSMimeError_ce_ptr = NULL;

zend_class_entry *TElSMimeErrors_ce_ptr = NULL;

zend_class_entry *TElMessagePartHandlerSMime_ce_ptr = NULL;

SB_PHP_METHOD(TElMessagePartHandlerSMime, GetDescription_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMessagePartHandlerSMime_GetDescription_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2043064448, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMessagePartHandlerSMime_GetDescription(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2043064448, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, DecoderIsSignedOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_DecoderIsSignedOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, DecoderIsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_DecoderIsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, DecoderIsCrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_DecoderIsCrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_UseSystemCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_UseSystemCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_UseSystemCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_UseSystemCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_CertificatesStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_CertificatesStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_CertificatesStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_CertificatesStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_Errors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSMimeErrorsRaw fOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_Errors(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_DecoderSignIsCorrectly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_DecoderSignIsCorrectly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_DecoderSignCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_DecoderSignCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_DecoderCryptCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_DecoderCryptCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_DecoderIncludeIssuerCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_DecoderIncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_DecoderIncludeIssuerCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_DecoderIncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderCrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderCrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderCrypted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderCrypted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSignBeforeCrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSignBeforeCrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSignBeforeCrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSignBeforeCrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSignOnlyClearFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSignOnlyClearFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSignOnlyClearFormat)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSignOnlyClearFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderMicalg)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMessagePartHandlerSMime_get_EncoderMicalg(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-724468063, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderMicalg)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderMicalg(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderCryptAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderCryptAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderCryptAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderCryptAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderCryptBitsInKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderCryptBitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderCryptBitsInKey)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderCryptBitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderIncludeIssuerCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderIncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderIncludeIssuerCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderIncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSignRootHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSignRootHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSignRootHeader)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSignRootHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSignTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSignTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSignTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSignTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_DecoderSignTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_DecoderSignTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderAlignEncryptedKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderAlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderAlignEncryptedKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderAlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderCryptCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderCryptCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderCryptCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderCryptCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderSignCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderSignCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderSignCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderSignCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, get_EncoderIgnoreCertAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMime_get_EncoderIgnoreCertAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, set_EncoderIgnoreCertAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMime_set_EncoderIgnoreCertAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMime, __construct)
{
	zval *oaParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaParams, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMime_Create(SBGetObjectHandle(oaParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_GetDescription_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_DecoderIsSignedOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_DecoderIsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_DecoderIsCrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_UseSystemCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_UseSystemCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_CertificatesStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_CertificatesStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_Errors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_DecoderSignIsCorrectly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_DecoderSignCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_DecoderCryptCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_DecoderIncludeIssuerCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_DecoderIncludeIssuerCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderCrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderCrypted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSignBeforeCrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSignBeforeCrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSignOnlyClearFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSignOnlyClearFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderMicalg, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderMicalg, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderCryptAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderCryptAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderCryptBitsInKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderCryptBitsInKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderIncludeIssuerCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderIncludeIssuerCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSignRootHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSignRootHeader, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSignTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSignTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_DecoderSignTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderAlignEncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderAlignEncryptedKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderCryptCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderCryptCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderSignCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderSignCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_get_EncoderIgnoreCertAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime_set_EncoderIgnoreCertAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMime___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aParams, TObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElMessagePartHandlerSMime_methods[] = {
	PHP_ME(TElMessagePartHandlerSMime, GetDescription_Inst, arginfo_TElMessagePartHandlerSMime_GetDescription_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, GetDescription, arginfo_TElMessagePartHandlerSMime_GetDescription, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMessagePartHandlerSMime, DecoderIsSignedOnly, arginfo_TElMessagePartHandlerSMime_DecoderIsSignedOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, DecoderIsSigned, arginfo_TElMessagePartHandlerSMime_DecoderIsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, DecoderIsCrypted, arginfo_TElMessagePartHandlerSMime_DecoderIsCrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, ClassType, arginfo_TElMessagePartHandlerSMime_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMessagePartHandlerSMime, get_UseSystemCertificates, arginfo_TElMessagePartHandlerSMime_get_UseSystemCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_UseSystemCertificates, arginfo_TElMessagePartHandlerSMime_set_UseSystemCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_CertificatesStorage, arginfo_TElMessagePartHandlerSMime_get_CertificatesStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_CertificatesStorage, arginfo_TElMessagePartHandlerSMime_set_CertificatesStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_CryptoProviderManager, arginfo_TElMessagePartHandlerSMime_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_CryptoProviderManager, arginfo_TElMessagePartHandlerSMime_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_Errors, arginfo_TElMessagePartHandlerSMime_get_Errors, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_DecoderSignIsCorrectly, arginfo_TElMessagePartHandlerSMime_get_DecoderSignIsCorrectly, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_DecoderSignCertStorage, arginfo_TElMessagePartHandlerSMime_get_DecoderSignCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_DecoderCryptCertStorage, arginfo_TElMessagePartHandlerSMime_get_DecoderCryptCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_DecoderIncludeIssuerCertificates, arginfo_TElMessagePartHandlerSMime_get_DecoderIncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_DecoderIncludeIssuerCertificates, arginfo_TElMessagePartHandlerSMime_set_DecoderIncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderCrypted, arginfo_TElMessagePartHandlerSMime_get_EncoderCrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderCrypted, arginfo_TElMessagePartHandlerSMime_set_EncoderCrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSignBeforeCrypt, arginfo_TElMessagePartHandlerSMime_get_EncoderSignBeforeCrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSignBeforeCrypt, arginfo_TElMessagePartHandlerSMime_set_EncoderSignBeforeCrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSigned, arginfo_TElMessagePartHandlerSMime_get_EncoderSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSigned, arginfo_TElMessagePartHandlerSMime_set_EncoderSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSignOnlyClearFormat, arginfo_TElMessagePartHandlerSMime_get_EncoderSignOnlyClearFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSignOnlyClearFormat, arginfo_TElMessagePartHandlerSMime_set_EncoderSignOnlyClearFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderMicalg, arginfo_TElMessagePartHandlerSMime_get_EncoderMicalg, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderMicalg, arginfo_TElMessagePartHandlerSMime_set_EncoderMicalg, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderCryptAlgorithm, arginfo_TElMessagePartHandlerSMime_get_EncoderCryptAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderCryptAlgorithm, arginfo_TElMessagePartHandlerSMime_set_EncoderCryptAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderCryptBitsInKey, arginfo_TElMessagePartHandlerSMime_get_EncoderCryptBitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderCryptBitsInKey, arginfo_TElMessagePartHandlerSMime_set_EncoderCryptBitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderIncludeIssuerCertificates, arginfo_TElMessagePartHandlerSMime_get_EncoderIncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderIncludeIssuerCertificates, arginfo_TElMessagePartHandlerSMime_set_EncoderIncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSignRootHeader, arginfo_TElMessagePartHandlerSMime_get_EncoderSignRootHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSignRootHeader, arginfo_TElMessagePartHandlerSMime_set_EncoderSignRootHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSignTime, arginfo_TElMessagePartHandlerSMime_get_EncoderSignTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSignTime, arginfo_TElMessagePartHandlerSMime_set_EncoderSignTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_DecoderSignTime, arginfo_TElMessagePartHandlerSMime_get_DecoderSignTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderAlignEncryptedKey, arginfo_TElMessagePartHandlerSMime_get_EncoderAlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderAlignEncryptedKey, arginfo_TElMessagePartHandlerSMime_set_EncoderAlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderCryptCertStorage, arginfo_TElMessagePartHandlerSMime_get_EncoderCryptCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderCryptCertStorage, arginfo_TElMessagePartHandlerSMime_set_EncoderCryptCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderSignCertStorage, arginfo_TElMessagePartHandlerSMime_get_EncoderSignCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderSignCertStorage, arginfo_TElMessagePartHandlerSMime_set_EncoderSignCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, get_EncoderIgnoreCertAddress, arginfo_TElMessagePartHandlerSMime_get_EncoderIgnoreCertAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, set_EncoderIgnoreCertAddress, arginfo_TElMessagePartHandlerSMime_set_EncoderIgnoreCertAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMime, __construct, arginfo_TElMessagePartHandlerSMime___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMessagePartHandlerSMime(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMessagePartHandlerSMime_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMessagePartHandlerSMime", TElMessagePartHandlerSMime_methods);
	if (NULL == TElMessagePartHandler_ce_ptr)
		Register_TElMessagePartHandler(TSRMLS_C);
	TElMessagePartHandlerSMime_ce_ptr = zend_register_internal_class_ex(&ce, TElMessagePartHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleSMIMEMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSMIMEMessage, get_SMIMEOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEMessage_get_SMIMEOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSimpleSMIMEOptions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, set_SMIMEOptions)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSimpleSMIMEOptions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEMessage_set_SMIMEOptions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSimpleSMIMEOptions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, get_EncryptCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEMessage_get_EncryptCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, set_EncryptCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEMessage_set_EncryptCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, get_SignCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEMessage_get_SignCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, set_SignCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEMessage_set_SignCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_get_SMIMEOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_set_SMIMEOptions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSimpleSMIMEOptions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_get_EncryptCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_set_EncryptCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_get_SignCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage_set_SignCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSMIMEMessage_methods[] = {
	PHP_ME(TElSimpleSMIMEMessage, get_SMIMEOptions, arginfo_TElSimpleSMIMEMessage_get_SMIMEOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, set_SMIMEOptions, arginfo_TElSimpleSMIMEMessage_set_SMIMEOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, get_EncryptCertStorage, arginfo_TElSimpleSMIMEMessage_get_EncryptCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, set_EncryptCertStorage, arginfo_TElSimpleSMIMEMessage_set_EncryptCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, get_SignCertStorage, arginfo_TElSimpleSMIMEMessage_get_SignCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, set_SignCertStorage, arginfo_TElSimpleSMIMEMessage_set_SignCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEMessage, __construct, arginfo_TElSimpleSMIMEMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSMIMEMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSMIMEMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSMIMEMessage", TElSimpleSMIMEMessage_methods);
	if (NULL == TElSimpleMIMEMessage_ce_ptr)
		Register_TElSimpleMIMEMessage(TSRMLS_C);
	TElSimpleSMIMEMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElSimpleMIMEMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleSMIMEOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSMIMEOptions, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEOptions_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_EncryptMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_EncryptMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_EncryptMessage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_EncryptMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_SignMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_SignMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_SignMessage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_SignMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_SignBeforeCrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_SignBeforeCrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_SignBeforeCrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_SignBeforeCrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_SignOnlyClearFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_SignOnlyClearFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_SignOnlyClearFormat)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_SignOnlyClearFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_MicAlg)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSMIMEOptions_get_MicAlg(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1339763739, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_MicAlg)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_MicAlg(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_EncryptAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_EncryptAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_EncryptAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_EncryptAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_EnryptBitsInKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_EnryptBitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_EnryptBitsInKey)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_EnryptBitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_IncludeIssuerCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_IncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_IncludeIssuerCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_IncludeIssuerCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_SignRootHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_SignRootHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_SignRootHeader)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_SignRootHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_SignTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_SignTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_SignTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_SignTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_AlignEncryptedKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_AlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_AlignEncryptedKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_AlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, get_IgnoreCertAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSMIMEOptions_get_IgnoreCertAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, set_IgnoreCertAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSMIMEOptions_set_IgnoreCertAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSMIMEOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSMIMEOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_EncryptMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_EncryptMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_SignMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_SignMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_SignBeforeCrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_SignBeforeCrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_SignOnlyClearFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_SignOnlyClearFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_MicAlg, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_MicAlg, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_EncryptAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_EncryptAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_EnryptBitsInKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_EnryptBitsInKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_IncludeIssuerCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_IncludeIssuerCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_SignRootHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_SignRootHeader, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_SignTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_SignTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_AlignEncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_AlignEncryptedKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_get_IgnoreCertAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions_set_IgnoreCertAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSMIMEOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSMIMEOptions_methods[] = {
	PHP_ME(TElSimpleSMIMEOptions, Assign, arginfo_TElSimpleSMIMEOptions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_CryptoProviderManager, arginfo_TElSimpleSMIMEOptions_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_CryptoProviderManager, arginfo_TElSimpleSMIMEOptions_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_EncryptMessage, arginfo_TElSimpleSMIMEOptions_get_EncryptMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_EncryptMessage, arginfo_TElSimpleSMIMEOptions_set_EncryptMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_SignMessage, arginfo_TElSimpleSMIMEOptions_get_SignMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_SignMessage, arginfo_TElSimpleSMIMEOptions_set_SignMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_SignBeforeCrypt, arginfo_TElSimpleSMIMEOptions_get_SignBeforeCrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_SignBeforeCrypt, arginfo_TElSimpleSMIMEOptions_set_SignBeforeCrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_SignOnlyClearFormat, arginfo_TElSimpleSMIMEOptions_get_SignOnlyClearFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_SignOnlyClearFormat, arginfo_TElSimpleSMIMEOptions_set_SignOnlyClearFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_MicAlg, arginfo_TElSimpleSMIMEOptions_get_MicAlg, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_MicAlg, arginfo_TElSimpleSMIMEOptions_set_MicAlg, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_EncryptAlgorithm, arginfo_TElSimpleSMIMEOptions_get_EncryptAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_EncryptAlgorithm, arginfo_TElSimpleSMIMEOptions_set_EncryptAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_EnryptBitsInKey, arginfo_TElSimpleSMIMEOptions_get_EnryptBitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_EnryptBitsInKey, arginfo_TElSimpleSMIMEOptions_set_EnryptBitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_IncludeIssuerCertificates, arginfo_TElSimpleSMIMEOptions_get_IncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_IncludeIssuerCertificates, arginfo_TElSimpleSMIMEOptions_set_IncludeIssuerCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_SignRootHeader, arginfo_TElSimpleSMIMEOptions_get_SignRootHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_SignRootHeader, arginfo_TElSimpleSMIMEOptions_set_SignRootHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_SignTime, arginfo_TElSimpleSMIMEOptions_get_SignTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_SignTime, arginfo_TElSimpleSMIMEOptions_set_SignTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_AlignEncryptedKey, arginfo_TElSimpleSMIMEOptions_get_AlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_AlignEncryptedKey, arginfo_TElSimpleSMIMEOptions_set_AlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, get_IgnoreCertAddress, arginfo_TElSimpleSMIMEOptions_get_IgnoreCertAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, set_IgnoreCertAddress, arginfo_TElSimpleSMIMEOptions_set_IgnoreCertAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSMIMEOptions, __construct, arginfo_TElSimpleSMIMEOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSMIMEOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSMIMEOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSMIMEOptions", TElSimpleSMIMEOptions_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElSimpleSMIMEOptions_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSMIMECore, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBSMIMECore_Initialize() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBSMIMECore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SMIME_STR_ALG_MD5, SB_SMIME_STR_ALG_MD5, SB_SMIME_STR_ALG_MD5);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SMIME_STR_ALG_SHA1, SB_SMIME_STR_ALG_SHA1, SB_SMIME_STR_ALG_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SMIME_STR_ALG_SHA256, SB_SMIME_STR_ALG_SHA256, SB_SMIME_STR_ALG_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SMIME_STR_ALG_SHA384, SB_SMIME_STR_ALG_SHA384, SB_SMIME_STR_ALG_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SMIME_STR_ALG_SHA512, SB_SMIME_STR_ALG_SHA512, SB_SMIME_STR_ALG_SHA512);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_BASE, SB_SMIME_ERROR_BASE, SB_SMIME_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE_STORAGE, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE_STORAGE, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE_STORAGE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE, SB_SMIME_ERROR_NO_SIGNING_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_HEADER_ASSEMBLING_FAILED, SB_SMIME_ERROR_HEADER_ASSEMBLING_FAILED, SB_SMIME_ERROR_HEADER_ASSEMBLING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE_STORAGE, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE_STORAGE, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE_STORAGE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE, SB_SMIME_ERROR_NO_ENCRYPTION_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_ENCRYPTION_FAILED, SB_SMIME_ERROR_ENCRYPTION_FAILED, SB_SMIME_ERROR_ENCRYPTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_UNKNOWN_DIGEST_ALGORITHM, SB_SMIME_ERROR_UNKNOWN_DIGEST_ALGORITHM, SB_SMIME_ERROR_UNKNOWN_DIGEST_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECore, SB_SMIME_ERROR_SIGNING_FAILED, SB_SMIME_ERROR_SIGNING_FAILED, SB_SMIME_ERROR_SIGNING_FAILED);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, CEnvelopedHeader, SB_CEnvelopedHeader, SB_CEnvelopedHeader);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, CSignedHeader, SB_CSignedHeader, SB_CSignedHeader);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, CSignatureHeader, SB_CSignatureHeader, SB_CSignatureHeader);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SDefaultMIMEPrefix, SB_SDefaultMIMEPrefix, SB_SDefaultMIMEPrefix);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SNoSigningCertificateStorage, SB_SNoSigningCertificateStorage, SB_SNoSigningCertificateStorage);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SNoSigningCertificate, SB_SNoSigningCertificate, SB_SNoSigningCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SFailedToAssembleOriginalPartHeader, SB_SFailedToAssembleOriginalPartHeader, SB_SFailedToAssembleOriginalPartHeader);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SNoEncryptionCertificateStorage, SB_SNoEncryptionCertificateStorage, SB_SNoEncryptionCertificateStorage);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SNoEncryptionCertificate, SB_SNoEncryptionCertificate, SB_SNoEncryptionCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSMIMECore, SUnknownDigestAlgorithm, SB_SUnknownDigestAlgorithm, SB_SUnknownDigestAlgorithm);
}

void Register_SBSMIMECore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElSMimeBoolState", NULL);
	TElSMimeBoolState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSMimeBoolState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeBoolState_ce_ptr, "smbsNull", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeBoolState_ce_ptr, "smbsFalse", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeBoolState_ce_ptr, "smbsTrue", 2)
	
	INIT_CLASS_ENTRY(ce, "TElSMimeType", NULL);
	TElSMimeType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSMimeType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeType_ce_ptr, "smtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeType_ce_ptr, "smtSignOnly", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeType_ce_ptr, "smtCryptOnly", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeType_ce_ptr, "smtSignAndCrypt", 3)
	
	INIT_CLASS_ENTRY(ce, "TElSMimeError", NULL);
	TElSMimeError_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSMimeError_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeSignaturePartNotFound", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeBodyPartNotFound", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeInvalidSignature", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeSigningCertificateMismatch", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeEncryptingCertificateMismatch", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeNoData", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeInvalidMessageDigest", 7)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeError_ce_ptr, "smeOmittedMessageDigest", 8)
	
	INIT_CLASS_ENTRY(ce, "TElSMimeErrors", NULL);
	TElSMimeErrors_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElSMimeErrors_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeUnknown", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeSignaturePartNotFound", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeBodyPartNotFound", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeInvalidSignature", 8)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeSigningCertificateMismatch", 16)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeEncryptingCertificateMismatch", 32)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeNoData", 64)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeInvalidMessageDigest", 128)
	SB_DECLARE_CLASS_LONG_CONST(TElSMimeErrors_ce_ptr, "smeOmittedMessageDigest", 256)
}

void Register_SBSMIMECore_Aliases(TSRMLS_D)
{
	if (NULL == TElMessagePartHandlerSMime_ce_ptr)
		Register_TElMessagePartHandlerSMime(TSRMLS_C);
	zend_register_class_alias("ElMessagePartHandlerSMime", TElMessagePartHandlerSMime_ce_ptr);
	if (NULL == TElSimpleSMIMEOptions_ce_ptr)
		Register_TElSimpleSMIMEOptions(TSRMLS_C);
	zend_register_class_alias("ElSimpleSMIMEOptions", TElSimpleSMIMEOptions_ce_ptr);
	if (NULL == TElSimpleSMIMEMessage_ce_ptr)
		Register_TElSimpleSMIMEMessage(TSRMLS_C);
	zend_register_class_alias("ElSimpleSMIMEMessage", TElSimpleSMIMEMessage_ce_ptr);
	if (NULL == TElSMimeBoolState_ce_ptr)
		Register_SBSMIMECore_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElSMimeBoolState", TElSMimeBoolState_ce_ptr);
	if (NULL == TElSMimeType_ce_ptr)
		Register_SBSMIMECore_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElSMimeType", TElSMimeType_ce_ptr);
	if (NULL == TElSMimeError_ce_ptr)
		Register_SBSMIMECore_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElSMimeError", TElSMimeError_ce_ptr);
	if (NULL == TElSMimeErrors_ce_ptr)
		Register_SBSMIMECore_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElSMimeErrors", TElSMimeErrors_ce_ptr);
}

