#include "sbtar.h"

SB_PHP_METHOD(TElBaseTarHeaderLow, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElBaseTarHeaderLow));
		intern->len = sizeof(TElBaseTarHeaderLow);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElBaseTarHeaderLow, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElBaseTarHeaderLow));
}

zend_class_entry *TElBaseTarHeaderLow_ce_ptr = NULL;

static zend_function_entry TElBaseTarHeaderLow_methods[] = {
	PHP_ME(TElBaseTarHeaderLow, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElBaseTarHeaderLow, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElBaseTarHeaderLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBaseTarHeaderLow_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElBaseTarHeaderLow", TElBaseTarHeaderLow_methods);
	TElBaseTarHeaderLow_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TElFileTarHeaderLow, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElFileTarHeaderLow));
		intern->len = sizeof(TElFileTarHeaderLow);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElFileTarHeaderLow, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElFileTarHeaderLow));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TElFileTarHeaderLow, get_Name)
{
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TElFileTarHeaderLow, set_Name)
{
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TElFileTarHeaderLow, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TElFileTarHeaderLow, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TElFileTarHeaderLow, get_Link)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TElFileTarHeaderLow, set_Link)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TElFileTarHeaderLow, get_LinkName)
{
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 21);
}

SB_PHP_METHOD(TElFileTarHeaderLow, set_LinkName)
{
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 21);
}

zend_class_entry *TElFileTarHeaderLow_ce_ptr = NULL;

static zend_function_entry TElFileTarHeaderLow_methods[] = {
	PHP_ME(TElFileTarHeaderLow, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElFileTarHeaderLow, get_Name, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, set_Name, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, get_Link, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, set_Link, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, get_LinkName, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTarHeaderLow, set_LinkName, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFileTarHeaderLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFileTarHeaderLow_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElFileTarHeaderLow", TElFileTarHeaderLow_methods);
	TElFileTarHeaderLow_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TElUStarTarHeaderLow, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElUStarTarHeaderLow));
		intern->len = sizeof(TElUStarTarHeaderLow);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElUStarTarHeaderLow, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElUStarTarHeaderLow));
}

zend_class_entry *TElUStarTarHeaderLow_ce_ptr = NULL;

static zend_function_entry TElUStarTarHeaderLow_methods[] = {
	PHP_ME(TElUStarTarHeaderLow, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElUStarTarHeaderLow, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElUStarTarHeaderLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUStarTarHeaderLow_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElUStarTarHeaderLow", TElUStarTarHeaderLow_methods);
	TElUStarTarHeaderLow_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TElTarEntryLow, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElTarEntryLow));
		intern->len = sizeof(TElTarEntryLow);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElTarEntryLow, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElTarEntryLow));
}

SB_PHP_METHOD(TElTarEntryLow, get_FilePos)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 57);
}

SB_PHP_METHOD(TElTarEntryLow, set_FilePos)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 57);
}

SB_PHP_METHOD(TElTarEntryLow, get_FileSize)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 65);
}

SB_PHP_METHOD(TElTarEntryLow, set_FileSize)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 65);
}

zend_class_entry *TElTarEntryLow_ce_ptr = NULL;

static zend_function_entry TElTarEntryLow_methods[] = {
	PHP_ME(TElTarEntryLow, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarEntryLow, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElTarEntryLow, get_FilePos, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarEntryLow, set_FilePos, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarEntryLow, get_FileSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarEntryLow, set_FileSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarEntryLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarEntryLow_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElTarEntryLow", TElTarEntryLow_methods);
	TElTarEntryLow_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarReaderLow_ce_ptr = NULL;

SB_PHP_METHOD(TElTarReaderLow, ExtractToStream)
{
	long l4Index;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarReaderLow_ExtractToStream(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReaderLow, LoadLibrary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarReaderLow_LoadLibrary(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReaderLow, get_Files)
{
	long l4FileIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4FileIndex) == SUCCESS)
	{
		TElFileTarHeaderLow roOutResult;
		SBCheckError(TElTarReaderLow_get_Files(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4FileIndex, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElFileTarHeaderLow_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TElFileTarHeaderLow) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReaderLow, get_FilesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTarReaderLow_get_FilesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReaderLow, __construct)
{
	zval *oTarStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTarStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarReaderLow_Create(SBGetObjectHandle(oTarStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReaderLow_ExtractToStream, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReaderLow_LoadLibrary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReaderLow_get_Files, 0, 0, 1)
	ZEND_ARG_INFO(0, FileIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReaderLow_get_FilesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReaderLow___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TarStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarReaderLow_methods[] = {
	PHP_ME(TElTarReaderLow, ExtractToStream, arginfo_TElTarReaderLow_ExtractToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReaderLow, LoadLibrary, arginfo_TElTarReaderLow_LoadLibrary, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReaderLow, get_Files, arginfo_TElTarReaderLow_get_Files, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReaderLow, get_FilesCount, arginfo_TElTarReaderLow_get_FilesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReaderLow, __construct, arginfo_TElTarReaderLow___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarReaderLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarReaderLow_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarReaderLow", TElTarReaderLow_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElTarReaderLow_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarWriterLow_ce_ptr = NULL;

SB_PHP_METHOD(TElTarWriterLow, AddFile)
{
	char *sFileName;
	int sFileName_len;
	long l4Mode;
	zval *dtDate;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sOl", &oStream, TStream_ce_ptr, &sFileName, &sFileName_len, &dtDate, php_date_get_date_ce(), &l4Mode) == SUCCESS)
	{
		SBCheckError(TElTarWriterLow_AddFile(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sFileName, (int32_t)sFileName_len, SBGetDateTime(dtDate TSRMLS_CC), (int32_t)l4Mode) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriterLow_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTarWriterLow_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, set_UID)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTarWriterLow_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTarWriterLow_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, set_GID)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTarWriterLow_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriterLow, __construct)
{
	zval *oTarStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTarStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriterLow_Create(SBGetObjectHandle(oTarStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_AddFile, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_OBJ_INFO(0, Date, DateTime, 0)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriterLow___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TarStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarWriterLow_methods[] = {
	PHP_ME(TElTarWriterLow, AddFile, arginfo_TElTarWriterLow_AddFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, Flush, arginfo_TElTarWriterLow_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, get_UID, arginfo_TElTarWriterLow_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, set_UID, arginfo_TElTarWriterLow_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, get_GID, arginfo_TElTarWriterLow_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, set_GID, arginfo_TElTarWriterLow_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriterLow, __construct, arginfo_TElTarWriterLow___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarWriterLow(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarWriterLow_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarWriterLow", TElTarWriterLow_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElTarWriterLow_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBTar_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorCreateTarFile, SB_SErrorCreateTarFile, SB_SErrorCreateTarFile);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorCreateFile, SB_SErrorCreateFile, SB_SErrorCreateFile);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorOpenFile, SB_SErrorOpenFile, SB_SErrorOpenFile);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorIndexFile, SB_SErrorIndexFile, SB_SErrorIndexFile);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorRepos, SB_SErrorRepos, SB_SErrorRepos);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorCorrupted, SB_SErrorCorrupted, SB_SErrorCorrupted);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorRead, SB_SErrorRead, SB_SErrorRead);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorWrite, SB_SErrorWrite, SB_SErrorWrite);
	SB_REGISTER_STRING_CONSTANT(SBTar, SErrorAttr, SB_SErrorAttr, SB_SErrorAttr);
	SB_REGISTER_LONG_CONSTANT(SBTar, BaseSize, SB_BaseSize, SB_BaseSize);
}

