#ifndef __INC_CSVISCII
#define __INC_CSVISCII

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlVISCIIHandle;

#ifdef SB_USE_CLASS_TPLVISCII
SB_IMPORT uint32_t SB_APIENTRY TPlVISCII_GetCategory(TPlVISCIIHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlVISCII_GetDescription(TPlVISCIIHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlVISCII_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlVISCII_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlVISCII_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLVISCII */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlVISCII_ce_ptr;

void Register_TPlVISCII(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSVISCII */

